function Create(self)
	--How long to wait until this becomes hittable again.
	self.invTime = 3000;
	self.timer = Timer();
	
	--The actor's limbs.
	self.limbs = {};
	
	--List of orbiting balls.
	self.balls = {};
	
	--Whether this is actually invincible or not.
	self.invincible = (respawns > 0);

	--Become temporarily invincible.
	if self.invincible then
		--Play the respawn sound.
		local sound = CreateAEmitter("Prison Escape Ep3.rte/Respawn Sound Emitter");
		sound.Pos = self.Pos;
		MovableMan:AddParticle(sound);
		
		for i=1,MovableMan:GetMOIDCount()-1 do
			local mo = MovableMan:GetMOFromID(i);
			if mo.RootID == self.ID then
				self.limbs[#self.limbs + 1] = mo;
				mo.GetsHitByMOs = false;
			end
		end
		
		--Create the orbiting balls.
		for i=1,8 do
			self.balls[i] = CreateMOPixel("Prison Escape Ep3.rte/Respawn Glow");
			MovableMan:AddParticle(self.balls[i]);
		end
	else
        self.GetsHitByMOs = true;
    end
end

function Update(self)
	if self.invincible then
		--Make balls orbit.
		local ang = -self.timer:LeftTillSimMS(0);
		local dist = (self.timer:LeftTillSimMS(self.invTime) / self.invTime) * 32;
		for i=1,#self.balls do
			self.balls[i].Pos = self.Pos + Vector(math.cos(ang + 45 * i) * dist,math.sin(ang + 45 * i) * dist);
			self.balls.ToDelete = false;
		end
		
		--Glow.
		self:FlashWhite(1);

		--Become vincible again.
		if self.timer:IsPastSimMS(self.invTime) then
			for k,v in pairs(self.limbs) do
				v.GetsHitByMOs = true;
			end
			
			for i=1,#self.balls do
				self.balls[i].ToDelete = true;
			end
            
            self.GetsHitByMOs = true;
			
			self.invincible = false;
		end
	end
end