dofile("Prison Escape Ep3.rte/Scripts/RobotEvents.lua");

--Spawns the boss and sets its variables up.
function PrisonEscapeMission3:InitBoss()
    --If this is the first idle sequence.
    self.firstIdle = true;

    --How much to multiply attack wait time by.
    self.waitX = 1;
    
    --The boss' maximum health.
    self.maxBossHealth = 250;
    
	if self.Difficulty <= GameActivity.CAKEDIFFICULTY then
		self.waitX = 1.25;
        self.maxBossHealth = 200;
	elseif self.Difficulty <= GameActivity.EASYDIFFICULTY then
		self.waitX = 1.1;
        self.maxBossHealth = 250;
	elseif self.Difficulty <= GameActivity.MEDIUMDIFFICULTY then
		self.waitX = 1;
        self.maxBossHealth = 250;
	elseif self.Difficulty <= GameActivity.HARDDIFFICULTY then
		self.waitX = 0.7;
        self.maxBossHealth = 300;
	elseif self.Difficulty <= GameActivity.NUTSDIFFICULTY then
		self.waitX = 0.65;
        self.maxBossHealth = 350;
	elseif self.Difficulty <= GameActivity.MAXDIFFICULTY then
		self.waitX = 0.6;
        self.maxBossHealth = 400;
	end
    
    --The boss' current health.
    pE3BossHealth = self.maxBossHealth;
    
    --Whether the boss is disabled.
    self.bossDisabled = false;

    --Spawn the boss parts.
    self.lowerBody = CreateMOSRotating("Prison Escape Ep3.rte/Boss Lower Body");
    MovableMan:AddParticle(self.lowerBody);
    self.upperBody = CreateMOSRotating("Prison Escape Ep3.rte/Boss Upper Body");
    MovableMan:AddParticle(self.upperBody);
    self.brainPanel = CreateMOSRotating("Prison Escape Ep3.rte/Boss Brain Panel");
    MovableMan:AddParticle(self.brainPanel);
    self.borno = CreateMOSRotating("Prison Escape Ep3.rte/Richard Borno");
    MovableMan:AddParticle(self.borno);
    
    --Arm A.
    self.rArmPartA = CreateMOSRotating("Prison Escape Ep3.rte/Boss Arm Segment A R");
    MovableMan:AddParticle(self.rArmPartA);
    self.rArmPartB = CreateMOSRotating("Prison Escape Ep3.rte/Boss Arm Segment B R");
    self.rArmPartB.RotAngle = math.pi * 1.5;
    MovableMan:AddParticle(self.rArmPartB);
    self.rWrist = CreateMOSRotating("Prison Escape Ep3.rte/Boss Wrist R");
    MovableMan:AddParticle(self.rWrist);
    self.rPincerA = CreateMOSRotating("Prison Escape Ep3.rte/Boss Pincer A");
    MovableMan:AddParticle(self.rPincerA);
    self.rPincerB = CreateMOSRotating("Prison Escape Ep3.rte/Boss Pincer B");
    MovableMan:AddParticle(self.rPincerB);
    
    --Arm B.
    self.lArmPartA = CreateMOSRotating("Prison Escape Ep3.rte/Boss Arm Segment A L");
    self.lArmPartA.RotAngle = math.pi;
    MovableMan:AddParticle(self.lArmPartA);
    self.lArmPartB = CreateMOSRotating("Prison Escape Ep3.rte/Boss Arm Segment B L");
    MovableMan:AddParticle(self.lArmPartB);
    self.lArmPartB.RotAngle = math.pi * 1.5;
    self.lWrist = CreateMOSRotating("Prison Escape Ep3.rte/Boss Wrist L");
    MovableMan:AddParticle(self.lWrist);
    self.lPincerA = CreateMOSRotating("Prison Escape Ep3.rte/Boss Pincer A");
    MovableMan:AddParticle(self.lPincerA);
    self.lPincerB = CreateMOSRotating("Prison Escape Ep3.rte/Boss Pincer B");
    MovableMan:AddParticle(self.lPincerB);
    
    --The boss' position.
    self.bossPos = Vector(1128, 650);
    
    --Whether the panel is still attached.
    self.panelOn = true;
    
    --Body part offsets.
    self.upperBodyOffset = Vector(0, 0);
    self.lowerBodyOffset = Vector(1, 90);
    self.brainPanelOffset = Vector(0, 20);
    self.rArmPartAOffset = Vector(71, -25);
    self.lArmPartAOffset = Vector(-71, -25);
    
    --Move the body into place.
    self.lowerBody.Pos = self.bossPos + Vector(1, 90);
    self.upperBody.Pos = self.bossPos;
    self.rArmPartA.Pos = self.upperBody.Pos + Vector(71, -25);
    self.lArmPartA.Pos = self.upperBody.Pos + Vector(-71, -25);
    
    --The length of an arm segment.
    self.segmentLength = 142;
    
    --The maximum extended length of the arm.
    self.maxLength = self.segmentLength  * 2;
    
    --Where the hands should move to.
    self.rHandPos = self.rArmPartA.Pos + Vector(self.segmentLength, self.segmentLength);
    self.lHandPos = self.lArmPartA.Pos + Vector(-self.segmentLength, self.segmentLength);
    
    --Whether the hands have crushing enabled.
    self.rHandCrush = false;
    self.lHandCrush = false;
    
    --The velocity to apply when crushing.
    self.rHandCrushVel = Vector(0, 0);
    self.lHandCrushVel = Vector(0, 0);
    
    --The minimum angle for the pincers, relative to the center of the claw.
    self.minClawOpen = 0.1;
    
    --The maximum angle for the pincers.
    self.maxClawOpen = math.pi * 0.25;
    
    --The amount that the claws are currently open.
    self.rClawOpen = self.minClawOpen;
    self.lClawOpen = self.minClawOpen;
    
    --The amount that the claws should interpolate toward.
    self.rIdealClawOpen = self.rClawOpen;
    self.lIdealClawOpen = self.lClawOpen;
    
    --The wrists' angles.
    self.rWristAngle = nil;
    self.lWristAngle = nil;
    
    --The angle for the wrists to interpolate toward.
    self.rIdealWristAngle = 0;
    self.lIdealWristAngle = 0;
    
    --Whether to flip the arms' angles.
    self.rFlipArm = false;
    self.lFlipArm = false;
    
    --Whether the boss should have red eyes.
    self.eyesRed = false;
    
    --Whether the boss should perform its heaving animation.
    self.bossHeaving = false;
    
    --The timer used for the heaving sine wave.
    self.heaveTimer = Timer();
    
    --How far to heave up and down.
    self.heaveAmount = 3;
    
    --How quickly to heave.
    self.heaveSpeed = 0.002;
    
    --Offset for heaving (keeps the position consistent when stopping and starting).
    self.heaveOffset = 0;
    
    --The pieces of the lifebar.
    self.lifebarPieces = {};

    --The different animation sets for the boss.
    self.animMode = { NONE = 0, IDLE = 1, REVEAL = 2, DEBUGREVEAL = 3, GROUNDSMASH = 4, SPRAYER = 5, AIRSMASH = 6, CLAP = 7, VACUUM = 8, CHICKENPECK = 9, GROUNDFLAMES = 10, CONCRETEWAVE = 11, SIDESMASH = 12, ENDSEQUENCE = 13, WIN = 14 };
    
    --The attack moves that the boss can randomly choose.
    self.moves = { self.animMode.GROUNDSMASH, self.animMode.SPRAYER, self.animMode.CLAP, self.animMode.VACUUM, self.animMode.CHICKENPECK, self.animMode.GROUNDFLAMES, self.animMode.CONCRETEWAVE };
    
    --The temporary moves list (removed when performed, then re-added when empty).
    self.tempMoves = CopyTable(self.moves);
    
    --The current animation set.
    self.curAnim = self.animMode.NONE;
    
    --The animation set to switch to.
    self.nextAnim = self.animMode.NONE;
    
    --Whether to start a new animation.
    self.startNewAnim = false;
    
    --The timer for the current animation.
    self.animTimer = Timer();
    
    --Tracks events within the animation.
    self.animEvent = 0;
    
    --The last attack this performed.
    self.lastAttack = -1;
    
    --Whether the ending sequence has been triggered.
    self.endSeqTriggered = false;
end

--Animation sequences for the boss.
function PrisonEscapeMission3:AnimateBoss()
    --If the boss is at 0 health or less, go to the end sequence.
    if pE3BossHealth <= 0 and not self.endSeqTriggered and self.curAnim ~= self.animMode.REVEAL then
        self:StartBossAnimation(self.animMode.ENDSEQUENCE);
    end
    
    --Go to the next animation.
    if self.startNewAnim then
        self:StopBossAnimation();
        self.curAnim = self.nextAnim;
        self.animTimer:Reset();
        self.animEvent = 0;
        self.startNewAnim = false;
    end
	
	--Stop the player from leaving
	if ((self.curAnim >= self.animMode.GROUNDSMASH and self.curAnim <= self.animMode.CONCRETEWAVE) or self.curAnim == self.animMode.IDLE) and (playerActor.Pos.X > self.cameraPos.X + 320 or playerActor.Pos.X < self.cameraPos.X - 320) then
        self:StartBossAnimation(self.animMode.SIDESMASH);
	end
    
    --Play the current animation, if there is one.
    if self.curAnim ~= self.animMode.NONE then
        local mainFunction = _G["PE3BossAnimation" .. self.curAnim];
        if mainFunction then
            mainFunction(self);
        end
        local eventFunction = _G["PE3BossAnimation" .. self.curAnim .. "_" .. self.animEvent];
        if eventFunction then
            eventFunction(self);
        end
    end

    --Heave up and down.
    if self.bossHeaving then
        self.upperBodyOffset.Y = math.sin((self.heaveTimer.ElapsedRealTimeMS + self.heaveOffset) * self.heaveSpeed) * self.heaveAmount;
    end
end

--Starts an animation.
function PrisonEscapeMission3:StartBossAnimation(newAnim)
    self.nextAnim = newAnim;
    self.startNewAnim = true;
end

--Abruptly ends the current boss animation. Only needs to be done on animations that spawn objects and keep them.
function PrisonEscapeMission3:StopBossAnimation()
    if self.curAnim == self.animMode.SPRAYER then
        if self.spraySound then
            self.spraySound.ToDelete = true;
        end
    elseif self.curAnim == self.animMode.GROUNDFLAMES then
        if self.burnSound then
            self.burnSound.ToDelete = true;
        end
    elseif self.curAnim == self.animMode.VACUUM then
        if self.vacuumSound then
            self.vacuumSound.ToDelete = true;
        end
    elseif self.curAnim == self.animMode.ENDSEQUENCE then
        if self.vacuumSound then
            self.vacuumSound.ToDelete = true;
        end
    end
    
    self.curAnim = self.animMode.NONE;
end

--Creates the life bar.
function PrisonEscapeMission3:InitLifeBar()
    if #self.lifebarPieces == 0 then
        for i = 0, 500 do
            self.lifebarPieces[i] = CreateMOSParticle("Prison Escape Ep3.rte/Life Bar Fill");
            self.lifebarPieces[i].Pos = self.cameraPos + Vector(-250 + i, -FrameMan.ResY * 0.5 + 40);
            if i == 0 or i == 500 then
                self.lifebarPieces[i].Frame = 0;
            else
                self.lifebarPieces[i].Frame = 2;
            end
            MovableMan:AddParticle(self.lifebarPieces[i]);
        end
    end
    self.lifebarName = CreateActor("Prison Escape Ep3.rte/Life Bar Name");
    self.lifebarName.Pos = self.cameraPos + Vector(0, -FrameMan.ResY * 0.5 + 40);
    MovableMan:AddActor(self.lifebarName);
end

--Removes the life bar.
function PrisonEscapeMission3:RemoveLifeBar()
    if #self.lifebarPieces ~= 0 then
        for i = 0, 500 do
            self.lifebarPieces[i].ToDelete = true;
        end
    end
    self.lifebarName.ToDelete = true;
    self.lifebarPieces = {};
end

--Moves to the next boss animation event.
function PrisonEscapeMission3:NextBossEvent(resetTimer)
    self.animEvent = self.animEvent + 1;
    if resetTimer then
        self.animTimer:Reset();
    end
end

--Erases a pixel and makes it glow.
function ErasePixel(pos)
    --We only need to erase if terrain is there.
    if SceneMan:GetTerrMatter(pos.X, pos.Y) ~= 0 then
        --Create the erase pixel.
        local pixel = CreateMOSRotating("Prison Escape Ep3.rte/Erase Pixel");
        
        --Place it.
        pixel.Pos = pos;
        
        --Spawn it.
        MovableMan:AddParticle(pixel);
        
        --Make the pixel cut out its shape in the terrain.
        pixel:ForceDeepCheck(true);
        
        --This is guaranteed to glow.
        glowChance = 1;
    end
    
    --Create the glow.
    if math.random() > 0.9 then
        local glow = CreateMOPixel("Prison Escape Ep3.rte/Erase Glow");
        glow.Pos = pos;
        MovableMan:AddParticle(glow);
    end
end

--Crushes actors touching a hand.
function PrisonEscapeMission3:HandCrush(right)
    local handPos, wristPos, crushVel;
    if right then
        handPos = self.rHandPos;
        wristPos = self.rWrist.Pos + Vector(24, 0):RadRotate(self.rWrist.RotAngle);
        crushVel = self.rHandCrushVel;
    else
        handPos = self.lHandPos;
        wristPos = self.lWrist.Pos + Vector(24, 0):RadRotate(self.lWrist.RotAngle);
        crushVel = self.lHandCrushVel;
    end
    
    for actor in MovableMan.Actors do
        if actor.GetsHitByMOs then
            if SceneMan:ShortestDistance(actor.Pos, wristPos, false).Magnitude <= 30 then
                actor.Vel = crushVel;
                GibActor(actor);
            end
        end
    end
end

--Spawns a smash effect.
function PrisonEscapeMission3:SmashEffect(pos, size)
    local smashEffect = CreateMOSRotating("Prison Escape Ep3.rte/Ground Smash " .. size);
    smashEffect.Pos = pos;
    MovableMan:AddParticle(smashEffect);
    smashEffect:GibThis();
    
    self:ShakeScreen(5, 1000);
end

--Flashes the boss' eyes.
function PrisonEscapeMission3:FlashEyes()
    local eyeEffectA = CreateMOPixel("Prison Escape Ep3.rte/Boss Eye Glow");
    eyeEffectA.Pos = self.upperBody.Pos + Vector(-6, -32);
    MovableMan:AddParticle(eyeEffectA);
    local eyeEffectB = CreateMOPixel("Prison Escape Ep3.rte/Boss Eye Glow");
    eyeEffectB.Pos = self.upperBody.Pos + Vector(6, -32);
    MovableMan:AddParticle(eyeEffectB);

    --Make the eye sound.
    local eyeSound = CreateAEmitter("Boss Eye Sound Emitter");
    eyeSound.Pos = self.bossPos;
    MovableMan:AddParticle(eyeSound);
end

--Starts or stops the heaving animation and automatically resets the timer.
function PrisonEscapeMission3:SetHeave(toHeave)
    --Reset the timer when it is turned on.
    if not self.bossHeaving and toHeave then
        self.heaveTimer:Reset();
    end
    
    --Update the offset when it is turned off.
    if self.bossHeaving and not toHeave then
        self.heaveOffset = self.heaveOffset + self.heaveTimer.ElapsedRealTimeMS;
    end
    
    self.bossHeaving = toHeave;
end

--Sets a wrist's angle for the boss.
function PrisonEscapeMission3:SetWristAngle(right, angle)
    if right then
        if angle == nil then
            self.rWristAngle = nil;
            self.rIdealWristAngle = nil;
            return;
        end
        self.rWristAngle = self.rWrist.RotAngle;
        self.rIdealWristAngle = angle;
    else
        if angle == nil then
            self.lWristAngle = nil;
            self.lIdealWristAngle = nil;
            return;
        end
        self.lWristAngle = self.lWrist.RotAngle;
        self.lIdealWristAngle = angle;
    end
end

--Resets lerp speeds.
function PrisonEscapeMission3:ResetLerpSpeeds()
    --Speed of arm interpolation.
    self.rArmPartALerpSpeed = 0.08;
    self.rArmPartBLerpSpeed = 0.08;
    self.lArmPartALerpSpeed = 0.08;
    self.lArmPartBLerpSpeed = 0.08;

    --The speed at which the claws interpolate.
    self.rClawLerpSpeed = 0.5;
    self.lClawLerpSpeed = 0.5;
    
    --The speed at which the wrists interpolate.
    self.rWristLerpSpeed = 0.08;
    self.lWristLerpSpeed = 0.08;
end

function PrisonEscapeMission3:UpdateArm(right, snap)
    if right then
        if snap then
            self.tempRArmPartALerpSpeed = self.rArmPartALerpSpeed;
            self.tempRArmPartBLerpSpeed = self.rArmPartBLerpSpeed;
            self.rArmPartALerpSpeed = 1;
            self.rArmPartBLerpSpeed = 1;
        end
        
        --Determine the differences between the hands and shoulders.
        local rHandOffset = SceneMan:ShortestDistance(self.rArmPartA.Pos, self.rHandPos, false);
        
        --Keep the hand in range.
        if rHandOffset.Magnitude > self.maxLength then
            rHandOffset = Vector(self.maxLength, 0):RadRotate(rHandOffset.AbsRadAngle);
            self.rHandPos = self.rArmPartA.Pos + rHandOffset;
        end
        
        --Reverse the hand offsets' Y components for trigonometric functions.
        rHandOffset.Y = -rHandOffset.Y;
        
        --Find the angles around the joints using law of cosines.
        local rJointAngle = CosLawAngle(self.segmentLength, self.segmentLength, rHandOffset.Magnitude);
        if rHandOffset.Magnitude >= self.segmentLength * 2 then
            rJointAngle = math.pi;
        end
        
        --Move the upper arm.
        local negate = -1;
        if self.rFlipArm then
            negate = 1;
        end
        
        self.rArmPartAIdealAngle = negate * -1 * (math.pi - rJointAngle) * 0.5 - rHandOffset.AbsRadAngle;
        self.rArmPartA.RotAngle = InterpolateAngle(self.rArmPartA.RotAngle, self.rArmPartAIdealAngle, self.rArmPartALerpSpeed);
        
        --Move the joint and lower arm.
        local rJointPos = self.rArmPartA.Pos + Vector(self.segmentLength, 0):RadRotate(self.rArmPartA.RotAngle);
        self.rArmPartB.Pos = rJointPos;
        self.rArmPartBIdealAngle = negate * (math.pi - rJointAngle) * 0.5 - rHandOffset.AbsRadAngle;
        self.rArmPartB.RotAngle = InterpolateAngle(self.rArmPartB.RotAngle, self.rArmPartBIdealAngle, self.rArmPartBLerpSpeed);
        
        --Move the wrists.
        self.rWrist.Pos = self.rArmPartB.Pos + Vector(116, 0):RadRotate(self.rArmPartB.RotAngle);
        if self.rWristAngle == nil then
            self.rWrist.RotAngle = self.rArmPartB.RotAngle;
        else
            self.rWrist.RotAngle = self.rWristAngle;
        end
        
        --Move pincer pieces.
        self.rPincerA.Pos = self.rWrist.Pos + Vector(0, -10):RadRotate(self.rWrist.RotAngle);
        self.rPincerA.RotAngle = self.rWrist.RotAngle + self.rClawOpen;
        self.rPincerB.Pos = self.rWrist.Pos + Vector(0, 10):RadRotate(self.rWrist.RotAngle);
        self.rPincerB.RotAngle = self.rWrist.RotAngle - self.rClawOpen;
        
        if snap then
            self.rArmPartALerpSpeed = self.tempRArmPartALerpSpeed;
            self.rArmPartBLerpSpeed = self.tempRArmPartBLerpSpeed;
        end
    else
        if snap then
            self.tempLArmPartALerpSpeed = self.lArmPartALerpSpeed;
            self.tempLArmPartBLerpSpeed = self.lArmPartBLerpSpeed;
            self.lArmPartALerpSpeed = 1;
            self.lArmPartBLerpSpeed = 1;
        end
    
        --Determine the differences between the hands and shoulders.
        local lHandOffset = SceneMan:ShortestDistance(self.lArmPartA.Pos, self.lHandPos, false);
        
        --Keep the hand in range.
        if lHandOffset.Magnitude > self.maxLength then
            lHandOffset = Vector(self.maxLength, 0):RadRotate(lHandOffset.AbsRadAngle);
            self.lHandPos = self.lArmPartA.Pos + lHandOffset;
        end
        
        --Reverse the hand offsets' Y components for trigonometric functions.
        lHandOffset.Y = -lHandOffset.Y;
        
        --Find the angles around the joints using law of cosines.
        local lJointAngle = CosLawAngle(self.segmentLength, self.segmentLength, lHandOffset.Magnitude);
        if lHandOffset.Magnitude >= self.segmentLength * 2 then
            lJointAngle = math.pi;
        end
        
        --Move the upper arm.
        local negate = 1;
        if self.lFlipArm then
            negate = -1;
        end
        
        self.lArmPartAIdealAngle = negate * -1 * (math.pi - lJointAngle) * 0.5 - lHandOffset.AbsRadAngle;
        self.lArmPartA.RotAngle = InterpolateAngle(self.lArmPartA.RotAngle, self.lArmPartAIdealAngle, self.lArmPartALerpSpeed);
        
        --Move the joint and lower arm.
        local lJointPos = self.lArmPartA.Pos + Vector(self.segmentLength, 0):RadRotate(self.lArmPartA.RotAngle);
        self.lArmPartB.Pos = lJointPos;
        self.lArmPartBIdealAngle = negate * (math.pi - lJointAngle) * 0.5 - lHandOffset.AbsRadAngle;
        self.lArmPartB.RotAngle = InterpolateAngle(self.lArmPartB.RotAngle, self.lArmPartBIdealAngle, self.lArmPartBLerpSpeed);
        
        --Move the wrists.
        self.lWrist.Pos = self.lArmPartB.Pos + Vector(116, 0):RadRotate(self.lArmPartB.RotAngle);
        if self.lWristAngle == nil then
            self.lWrist.RotAngle = self.lArmPartB.RotAngle;
        else
            self.lWrist.RotAngle = self.lWristAngle;
        end
        
        --Move pincer pieces.
        self.lPincerA.Pos = self.lWrist.Pos + Vector(0, -10):RadRotate(self.lWrist.RotAngle);
        self.lPincerA.RotAngle = self.lWrist.RotAngle + self.lClawOpen;
        self.lPincerB.Pos = self.lWrist.Pos + Vector(0, 10):RadRotate(self.lWrist.RotAngle);
        self.lPincerB.RotAngle = self.lWrist.RotAngle - self.lClawOpen;
        
        if snap then
            self.lArmPartALerpSpeed = self.tempLArmPartALerpSpeed;
            self.lArmPartBLerpSpeed = self.tempLArmPartBLerpSpeed;
        end
    end
end

--Updates all of the boss' parts.
function PrisonEscapeMission3:UpdateBoss()
    --Crush things around the hands.
    if self.rHandCrush then
        self:HandCrush(true);
    end
    if self.lHandCrush then
        self:HandCrush(false);
    end

    --Change the eyes.
    if self.eyesRed then
        self.upperBody.Frame = 1;
    else
        self.upperBody.Frame = 0;
    end

    --Move body parts into place.
    self.upperBody.Pos = self.bossPos + self.upperBodyOffset;
    self.borno.Pos = self.upperBody.Pos + Vector(0, 9);
    if self.panelOn then
        self.brainPanel.Pos = self.upperBody.Pos + self.brainPanelOffset;
    end
    self.lowerBody.Pos = self.bossPos + self.lowerBodyOffset;
    self.rArmPartA.Pos = self.upperBody.Pos + self.rArmPartAOffset;
    self.lArmPartA.Pos = self.upperBody.Pos + self.lArmPartAOffset;
    
    --Interpolate claw opening.
    self.rClawOpen = InterpolateAngle(self.rClawOpen, self.rIdealClawOpen, self.rClawLerpSpeed);
    self.lClawOpen = InterpolateAngle(self.lClawOpen, self.lIdealClawOpen, self.lClawLerpSpeed);
    
    --Interpolate the wrist angles.
    if self.rWristAngle ~= nil then
        self.rWristAngle = InterpolateAngle(self.rWristAngle, self.rIdealWristAngle, self.rWristLerpSpeed);
    end
    if self.lWristAngle ~= nil then
        self.lWristAngle = InterpolateAngle(self.lWristAngle, self.lIdealWristAngle, self.lWristLerpSpeed);
    end
    
    --Move the right and left arms.
    self:UpdateArm(true, false);
    self:UpdateArm(false, false);
end