

-- 0 (NONE)
--No animation.
function PE3BossAnimation0(self)

end

function PE3BossAnimation0_0(self)

end

-- 1 (IDLE)
--Idling above ground.
function PE3BossAnimation1(self)
    --Choose an animation.
    if self.animEvent > 0 then
        local waitTime = 4000 * self.waitX;
        if self.firstIdle then
            waitTime = 6000;
            --Make the brain panel hittable and enable the player on the first run.
            if self.switchTimer:IsPastSimMS(3000) and not self.brainPanel.HitsMOs then
                self.brainPanel.HitsMOs = true;
                self.brainPanel.GetsHitByMOs = true;
                
                self.targetMode = Controller.CIM_PLAYER;
                self:SwitchToActor(playerActor, Activity.PLAYER_1, Activity.TEAM_1);
            end
        end
        if self.switchTimer:IsPastSimMS(waitTime) then
            self.firstIdle = false;
        
            if not self:ActivityOver() then
                local newAnim = self.animMode.IDLE;
                
                --Smash the player out of the sky if he's up there.
                if playerActor.Pos.Y < self.upperBody.Pos.Y then
                    newAnim = self.animMode.AIRSMASH;
                else
                    local rand = -1;
                    newAnim = lastAttack;
                    while newAnim == lastAttack do
                        rand = math.random(1, #self.tempMoves);
                        newAnim = self.tempMoves[rand];
                    end
                    lastAttack = newAnim;
                    
                    --Remove the item from the list of possible moves.
                    table.remove(self.tempMoves, rand);
                    
                    --Re-populate the table if all the attacks have been performed.
                    if #self.tempMoves == 0 then
                        self.tempMoves = CopyTable(self.moves);
                    end
                end
                
                self:StartBossAnimation(newAnim);
            end
        end
    end
end

function PE3BossAnimation1_0(self)
    --Heave.
    self:SetHeave(true);
    
    --Reset lerp speeds.
    self:ResetLerpSpeeds();

    --Assume a neutral position.
    self.rHandPos = self.rArmPartA.Pos + Vector(self.segmentLength, self.segmentLength * 0.5);
    self.lHandPos = self.lArmPartA.Pos + Vector(-self.segmentLength, self.segmentLength * 0.5);
    self.lFlipArm = false;
    self.rFlipArm = false;
    self.rIdealClawOpen = self.minClawOpen;
    self.lIdealClawOpen = self.minClawOpen;
    self:SetWristAngle(true, nil);
    self:SetWristAngle(false, nil);
    self.rHandCrush = false;
    self.lHandCrush = false;
    
    --Timer for when to switch to the next animation.
    self.switchTimer = Timer();
    
    self:NextBossEvent(true);
end

--Open claws.
function PE3BossAnimation1_1(self)
    if self.animTimer:IsPastSimMS(2000) then
        self.rIdealClawOpen = self.maxClawOpen;
        self.lIdealClawOpen = self.maxClawOpen;
        
        local clawSound = CreateAEmitter("Prison Escape Ep3.rte/Claw Servo Open Sound Emitter");
        clawSound.Pos = self.bossPos;
        MovableMan:AddParticle(clawSound);
        
        self:NextBossEvent(true);
    end
end

--Close claws.
function PE3BossAnimation1_2(self)
    if self.animTimer:IsPastSimMS(150) then
        self.rIdealClawOpen = self.minClawOpen;
        self.lIdealClawOpen = self.minClawOpen;
        
        local clawSound = CreateAEmitter("Prison Escape Ep3.rte/Claw Servo Close Sound Emitter");
        clawSound.Pos = self.bossPos;
        MovableMan:AddParticle(clawSound);
        
        self:NextBossEvent(true);
    end
end

--Open claws.
function PE3BossAnimation1_3(self)
    if self.animTimer:IsPastSimMS(150) then
        self.rIdealClawOpen = self.maxClawOpen;
        self.lIdealClawOpen = self.maxClawOpen;
        
        local clawSound = CreateAEmitter("Prison Escape Ep3.rte/Claw Servo Open Sound Emitter");
        clawSound.Pos = self.bossPos;
        MovableMan:AddParticle(clawSound);
        
        self:NextBossEvent(true);
    end
end

--Close claws.
function PE3BossAnimation1_4(self)
    if self.animTimer:IsPastSimMS(150) then
        self.rIdealClawOpen = self.minClawOpen;
        self.lIdealClawOpen = self.minClawOpen;
        
        local clawSound = CreateAEmitter("Prison Escape Ep3.rte/Claw Servo Close Sound Emitter");
        clawSound.Pos = self.bossPos;
        MovableMan:AddParticle(clawSound);
        
        self.animTimer:Reset();
        self.animEvent = 1;
    end
end

-- 2 (REVEAL)
--Revealing itself from hiding.
function PE3BossAnimation2(self)
    --Increase health.
    if self.animEvent >= 10 and self.animEvent <= 12 then
        --Increase the health.
        pE3BossHealth = self.maxBossHealth * ((self.animTimer.ElapsedRealTimeMS - 4235) / 1400);
        
        if pE3BossHealth > self.maxBossHealth then
            pE3BossHealth = self.maxBossHealth;
        end
    end
end

function PE3BossAnimation2_0(self)
    --Play the music.
    AudioMan:ClearMusicQueue();
    AudioMan:PlayMusic("Prison Escape Ep3.rte/Sound/Music/ChromeHavoc5.ogg", 0, -1);
    AudioMan:QueueMusicStream("Prison Escape Ep3.rte/Sound/Music/ChromeHavocLoop.ogg");

    --Don't heave.
    self:SetHeave(false);

    --Move the hands so they smash up, and not around the side.
    self.rHandPos = self.rArmPartA.Pos + Vector(self.segmentLength, 0);
    self.lHandPos = self.lArmPartA.Pos + Vector(-self.segmentLength, 0);
    
    --Flip the arms.
    self.rFlipArm = true;
    self.lFlipArm = true;
    
    --Snap them into position.
    self:UpdateArm(true, true);
    self:UpdateArm(false, true);
    
    --Set the hands to a higher lerp speed.
    self.rArmPartALerpSpeed = 0.5;
    self.rArmPartBLerpSpeed = 0.5;
    self.lArmPartALerpSpeed = 0.5;
    self.lArmPartBLerpSpeed = 0.5;
    self.rWristLerpSpeed = 0.3;
    self.lWristLerpSpeed = 0.3;
    
    --Smash the right hand through the ground.
    self.rHandPos = Vector(1250, 420);
    self:SmashEffect(Vector(1300, 510), "Large");
    
    --Turn off collisions for now.
    self.upperBody.HitsMOs = false;
    self.upperBody.GetsHitByMOs = false;
    self.brainPanel.HitsMOs = false;
    self.brainPanel.GetsHitByMOs = false;
    self.borno.HitsMOs = false;
    self.borno.GetsHitByMOs = false;
    
    --Make the player look.
    playerActor:SetAimAngle(math.pi * 0.25);
    playerActor.HFlipped = false;
    
    --Don't heave.
    self.bossHeaving = false;
    
    self:NextBossEvent(false);
end

function PE3BossAnimation2_1(self)
    --Smash the left hand through the ground.
    if self.animTimer:IsPastRealMS(529) then
        self.lHandPos = Vector(1006, 420);
        self:SmashEffect(Vector(956, 510), "Large");
        
        --Make the player look.
        playerActor:SetAimAngle(math.pi * 0.25);
        playerActor.HFlipped = true;
        
        --Send Fiona flying.
        self.partner.Vel = Vector(40, -55);
        local painSound = CreateAEmitter("Prison Escape Ep3.rte/Female Extreme Pain Sound Emitter");
        painSound.Pos = self.bossPos;
        MovableMan:AddParticle(painSound);
        
        self:NextBossEvent(false);
    end
end
    
function PE3BossAnimation2_2(self)
    --Open the claws.
    if self.animTimer:IsPastRealMS(882) then
        self.rIdealClawOpen = self.maxClawOpen;
        self.lIdealClawOpen = self.maxClawOpen;
        
        local clawSound = CreateAEmitter("Prison Escape Ep3.rte/Claw Servo Open Sound Emitter");
        clawSound.Pos = self.bossPos;
        MovableMan:AddParticle(clawSound);
        
        self:NextBossEvent(false);
    end
end
    
function PE3BossAnimation2_3(self)
    --Close the claws.
    if self.animTimer:IsPastRealMS(1059) then
        self.rIdealClawOpen = self.minClawOpen;
        self.lIdealClawOpen = self.minClawOpen;
        
        local clawSound = CreateAEmitter("Prison Escape Ep3.rte/Claw Servo Close Sound Emitter");
        clawSound.Pos = self.bossPos;
        MovableMan:AddParticle(clawSound);
        
        self:NextBossEvent(false);
    end
end
    
function PE3BossAnimation2_4(self)
    --Move the hands out.
    if self.animTimer:IsPastRealMS(1411) then
        --Set the hands to a higher lerp speed.
        self.rArmPartALerpSpeed = 0.3;
        self.rArmPartBLerpSpeed = 0.3;
        self.lArmPartALerpSpeed = 0.3;
        self.lArmPartBLerpSpeed = 0.3;
        
        self.rHandPos.X = self.rHandPos.X + 125;
        self.lHandPos.X = self.lHandPos.X - 125;
        
        self:NextBossEvent(false);
    end
end
    
function PE3BossAnimation2_5(self)
    --Rotate the hands for grip.
    if self.animTimer:IsPastRealMS(1980) then
        self:SetWristAngle(true, math.pi * 1.5);
        self:SetWristAngle(false, math.pi * 1.5);
        
        self:NextBossEvent(false);
    end
end

function PE3BossAnimation2_6(self)
    --Bring the hands down.
    if self.animTimer:IsPastRealMS(2823) then
        --Set the hands to a lower lerp speed.
        self.rArmPartALerpSpeed = 0.25;
        self.rArmPartBLerpSpeed = 0.25;
        self.lArmPartALerpSpeed = 0.25;
        self.lArmPartBLerpSpeed = 0.25;
    
        self.rHandPos.Y = self.rHandPos.Y + 60;
        self.lHandPos.Y = self.lHandPos.Y + 60;
        self.rIdealClawOpen = self.maxClawOpen;
        self.lIdealClawOpen = self.maxClawOpen;
        
        self:SmashEffect(self.rHandPos + Vector(0, 32), "Small");
        self:SmashEffect(self.rHandPos + Vector(32, 32), "Small Silent");
        self:SmashEffect(self.lHandPos + Vector(0, 32), "Small Silent");
        self:SmashEffect(self.lHandPos + Vector(32, 32), "Small");
        
        self:NextBossEvent(false);
    end
end
    
function PE3BossAnimation2_7(self)
    --Move the boss up.
    if self.animTimer:IsPastRealMS(3352) then
        self.bossStartPos = Vector(self.bossPos.X, self.bossPos.Y);
        
        --Set the hands to a higher lerp speed to compensate for the body.
        self.rArmPartALerpSpeed = 1;
        self.rArmPartBLerpSpeed = 1;
        self.lArmPartALerpSpeed = 1;
        self.lArmPartBLerpSpeed = 1;
        
        --Make the player look.
        playerActor:SetAimAngle(-math.pi * 0.5);
        
        --Smash the concrete around the boss.
        for i = self.bossPos.X - 100, self.bossPos.X + 100, 33 do
            self:SmashEffect(Vector(i, 510), "Large");
        end
        
        self:NextBossEvent(false);
    end
end
    
function PE3BossAnimation2_8(self)
    self.bossPos.Y = self.bossPos.Y + ((self.bossStartPos.Y - 100) - self.bossPos.Y) * 0.2;
    
    if self.animTimer.ElapsedRealTimeMS > 3700 then
        self.bossPos.Y = self.bossStartPos.Y - 100;
        self:NextBossEvent(false);
    end
end
    
function PE3BossAnimation2_9(self)
    --Begin rising.
    if self.animTimer:IsPastRealMS(4235) then
        self.bossStartPos = Vector(self.bossPos.X, self.bossPos.Y);
        self.rHandStartPos = Vector(self.rHandPos.X, self.rHandPos.Y);
        self.lHandStartPos = Vector(self.lHandPos.X, self.lHandPos.Y);
        self.animEvent = 10;
        
        --Create the life bar.
        self:InitLifeBar();
        pE3BossHealth = 0;
        
        --Make the startup sound.
        local startupSound = CreateAEmitter("Prison Escape Ep3.rte/Boss Startup Sound Emitter");
        startupSound.Pos = self.bossPos;
        MovableMan:AddParticle(startupSound);
    end
end
        
--Rise.
function PE3BossAnimation2_10(self)
    local multiplier = ((self.animTimer.ElapsedRealTimeMS - 4235) / 1059);
    self.bossPos.Y = self.bossStartPos.Y + (355 - self.bossStartPos.Y) * multiplier;
    
    --Move hands to compensate for body movement.
    self.rHandPos.Y = self.rHandStartPos.Y + 32 * multiplier;
    self.lHandPos.Y = self.lHandStartPos.Y + 32 * multiplier;
    
    --Make the player look.
    playerActor:SetAimAngle(math.pi * multiplier - math.pi * 0.5);
    
    --Shake the whole time.
    self:ShakeScreen(5, 1000);
    
    --Stop when time is up.
    if self.animTimer.ElapsedRealTimeMS > 5294 then
        self.bossPos.Y = 355;
        self:NextBossEvent(false);
    end
end
    
function PE3BossAnimation2_11(self)
    --Flash the eyes.
    if self.animTimer:IsPastRealMS(5600) then
        self.eyesRed = true;
        self:FlashEyes();
        
        self:NextBossEvent(false);
    end
end
    
function PE3BossAnimation2_12(self)
    --Finish the animation.
    if self.animTimer:IsPastRealMS(5647) then
        --Show its name.
        self:GetBanner(GUIBanner.YELLOW, Activity.PLAYER_1):ShowText("JUNKERNAUT", GUIBanner.FLYBYLEFTWARD, 1000, Vector(FrameMan.PlayerScreenWidth, FrameMan.PlayerScreenHeight), 0.5, 1000, 100);
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation2_13(self)
    --Return to idling.
    if self.animTimer:IsPastSimMS(100) then
        --Turn on collisions again.
        self.upperBody.HitsMOs = true;
        self.upperBody.GetsHitByMOs = true;
        self.borno.HitsMOs = true;
        self.borno.GetsHitByMOs = true;
    
        --Blabber.
        self:Speak(self.borno, "Ready to die, Dafred?!", 4000);
    
        --Idle.
        self:StartBossAnimation(self.animMode.IDLE);
    end
end

-- 3 (DEBUGREVEAL)
--Reveal with no animation.
function PE3BossAnimation3(self)
    self.bossPos.Y = 355;
    self.eyesRed = true;
    self:InitLifeBar();
    self.partner.ToDelete = true;
    self:UpdateBoss();
    self:StartBossAnimation(self.animMode.IDLE);
end

function PE3BossAnimation3_0(self)

end

-- 4 (GROUNDSMASH)
--Smashing from outside to inside.
function PE3BossAnimation4(self)

end

function PE3BossAnimation4_0(self)
    self:SetHeave(false);

    --Move the hands into place.
    self.rHandPos = self.rArmPartA.Pos + Vector(200, 75);
    self.lHandPos = self.lArmPartA.Pos + Vector(-200, 75);
    self:SetWristAngle(true, math.pi * 1.5);
    self:SetWristAngle(false, math.pi * 1.5);
    self.rIdealClawOpen = self.minClawOpen;
    self.lIdealClawOpen = self.minClawOpen;
    
    --Crushes will all be downward.
    self.rHandCrushVel = Vector(0, 25);
    self.lHandCrushVel = Vector(0, 25);
    
    self:NextBossEvent(true);
end
    
function PE3BossAnimation4_1(self)
    --Flash the eyes as a warning.
    if self.animTimer:IsPastSimMS(500 * self.waitX) then
        self:FlashEyes();
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation4_2(self)
    --Smash the hands down.
    if self.animTimer:IsPastSimMS(550 * self.waitX) then
        self.lHandCrush = true;
        self.rHandCrush = true;
    
        self.rArmPartALerpSpeed = 0.4;
        self.rArmPartBLerpSpeed = 0.4;
        self.lArmPartALerpSpeed = 0.4;
        self.lArmPartBLerpSpeed = 0.4;
        
        self.rHandPos.Y = self.bossPos.Y + 160;
        self:SmashEffect(SceneMan:MovePointToGround(Vector(self.rHandPos.X, 0), 5, 2), "Small");
        self.lHandPos.Y = self.bossPos.Y + 160;
        self:SmashEffect(SceneMan:MovePointToGround(Vector(self.lHandPos.X, 0), 5, 2), "Small");
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation4_3(self)
    --Disable the hand crushing once it hits the ground.
    if self.animTimer:IsPastSimMS(100) then
        self.lHandCrush = false;
        self.rHandCrush = false;
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation4_4(self)
    --Move the hands into place.
    if self.animTimer:IsPastSimMS(400 * self.waitX) then
        self.rHandPos = self.rArmPartA.Pos + Vector(150, 75);
        self.lHandPos = self.lArmPartA.Pos + Vector(-150, 75);
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation4_5(self)
    --Flash the eyes as a warning.
    if self.animTimer:IsPastSimMS(500 * self.waitX) then
        self:FlashEyes();
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation4_6(self)
    --Smash the hands down.
    if self.animTimer:IsPastSimMS(550 * self.waitX) then
        self.lHandCrush = true;
        self.rHandCrush = true;
        
        self.rHandPos.Y = self.bossPos.Y + 160;
        self:SmashEffect(SceneMan:MovePointToGround(Vector(self.rHandPos.X, 0), 5, 2), "Small");
        self.lHandPos.Y = self.bossPos.Y + 160;
        self:SmashEffect(SceneMan:MovePointToGround(Vector(self.lHandPos.X, 0), 5, 2), "Small");
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation4_7(self)
    --Disable the hand crushing once it hits the ground.
    if self.animTimer:IsPastSimMS(100) then
        self.lHandCrush = false;
        self.rHandCrush = false;
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation4_8(self)
    --Move the hands into place.
    if self.animTimer:IsPastSimMS(400 * self.waitX) then
        self.rHandPos = self.rArmPartA.Pos + Vector(100, 75);
        self.lHandPos = self.lArmPartA.Pos + Vector(-100, 75);
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation4_9(self)
    --Flash the eyes as a warning.
    if self.animTimer:IsPastSimMS(500 * self.waitX) then
        self:FlashEyes();
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation4_10(self)
    --Smash the hands down.
    if self.animTimer:IsPastSimMS(550 * self.waitX) then
        self.lHandCrush = true;
        self.rHandCrush = true;
        
        self.rHandPos.Y = self.bossPos.Y + 160;
        self:SmashEffect(SceneMan:MovePointToGround(Vector(self.rHandPos.X + 5, 0), 5, 2), "Small");
        self.lHandPos.Y = self.bossPos.Y + 160;
        self:SmashEffect(SceneMan:MovePointToGround(Vector(self.lHandPos.X - 5, 0), 5, 2), "Small");
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation4_11(self)
    --Disable the hand crushing once it hits the ground.
    if self.animTimer:IsPastSimMS(100) then
        self.lHandCrush = false;
        self.rHandCrush = false;
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation4_12(self)
    --Move the hands into place.
    if self.animTimer:IsPastSimMS(400 * self.waitX) then
        self.rHandPos = self.rArmPartA.Pos + Vector(50, 75);
        self.lHandPos = self.lArmPartA.Pos + Vector(-50, 75);
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation4_13(self)
    --Flash the eyes as a warning.
    if self.animTimer:IsPastSimMS(500 * self.waitX) then
        self:FlashEyes();
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation4_14(self)
    --Smash the hands down.
    if self.animTimer:IsPastSimMS(550 * self.waitX) then
        self.lHandCrush = true;
        self.rHandCrush = true;
        
        self.rHandPos.Y = self.bossPos.Y + 160;
        self:SmashEffect(SceneMan:MovePointToGround(Vector(self.rHandPos.X + 10, 0), 5, 2), "Small");
        self.lHandPos.Y = self.bossPos.Y + 160;
        self:SmashEffect(SceneMan:MovePointToGround(Vector(self.lHandPos.X - 10, 0), 5, 2), "Small");
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation4_15(self)
    --Disable the hand crushing once it hits the ground.
    if self.animTimer:IsPastSimMS(100) then
        self.lHandCrush = false;
        self.rHandCrush = false;
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation4_16(self)
    --Move the hands into place.
    if self.animTimer:IsPastSimMS(400 * self.waitX) then
        self.rHandPos = self.rArmPartA.Pos + Vector(0, 65);
        self.lHandPos = self.lArmPartA.Pos + Vector(0, 65);
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation4_17(self)
    --Flash the eyes as a warning.
    if self.animTimer:IsPastSimMS(500 * self.waitX) then
        self:FlashEyes();
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation4_18(self)
    --Smash the hands down.
    if self.animTimer:IsPastSimMS(550 * self.waitX) then
        self.lHandCrush = true;
        self.rHandCrush = true;
        
        self.rHandPos.Y = self.bossPos.Y + 160;
        self:SmashEffect(SceneMan:MovePointToGround(Vector(self.rHandPos.X + 20, 0), 5, 2), "Small");
        self.lHandPos.Y = self.bossPos.Y + 160;
        self:SmashEffect(SceneMan:MovePointToGround(Vector(self.lHandPos.X - 20, 0), 5, 2), "Small");
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation4_19(self)
    --Disable the hand crushing once it hits the ground.
    if self.animTimer:IsPastSimMS(100) then
        self.lHandCrush = false;
        self.rHandCrush = false;
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation4_20(self)
    --Move the hands into place.
    if self.animTimer:IsPastSimMS(400 * self.waitX) then
        self.rHandPos = self.rArmPartA.Pos + Vector(-55, 50);
        self.lHandPos = self.lArmPartA.Pos + Vector(55, 50);
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation4_21(self)
    --Flash the eyes as a warning.
    if self.animTimer:IsPastSimMS(500 * self.waitX) then
        self:FlashEyes();
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation4_22(self)
    --Smash the hands down.
    if self.animTimer:IsPastSimMS(550 * self.waitX) then
        self.lHandCrush = true;
        self.rHandCrush = true;
        
        self.rHandPos.Y = self.bossPos.Y + 160;
        self:SmashEffect(SceneMan:MovePointToGround(Vector(self.rHandPos.X + 25, 0), 5, 2), "Small");
        self.lHandPos.Y = self.bossPos.Y + 160;
        self:SmashEffect(SceneMan:MovePointToGround(Vector(self.lHandPos.X - 25, 0), 5, 2), "Small");
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation4_23(self)
    --Disable the hand crushing once it hits the ground.
    if self.animTimer:IsPastSimMS(100) then
        self.lHandCrush = false;
        self.rHandCrush = false;
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation4_24(self)
    --Return to idling.
    if self.animTimer:IsPastSimMS(400 * self.waitX) then
        self:ResetLerpSpeeds();
        self:StartBossAnimation(self.animMode.IDLE);
    end
end

-- 5 (SPRAYER)
--Bury the player in concrete, then fire a laser.
function PE3BossAnimation5(self)
    if self.animEvent >= 1 and self.animEvent <= 3 then
        --Determine which side the player is on.
        if self.switchTimer:IsPastSimMS(1000) or self.ignoreSwitchTimer then
            if playerActor.Pos.X < self.bossPos.X then
                if self.playerRight then
                    self.playerRight = false;
                    self.sideSwitched = true;
                end
            else
                if not self.playerRight then
                    self.playerRight = true;
                    self.sideSwitched = true;
                end
            end
        end
        
        --Orient the hands when the side has been switched.
        if self.sideSwitched then
            if self.playerRight then
                self.rIdealClawOpen = self.maxClawOpen;
                self.lIdealClawOpen = self.minClawOpen;
                self:SetWristAngle(false, nil);
            else
                self.lIdealClawOpen = self.maxClawOpen;
                self.rIdealClawOpen = self.minClawOpen;
                self:SetWristAngle(true, nil);
            end
            
            self.sideSwitched = false;
            self.ignoreSwitchTimer = false;
            self.switchTimer:Reset();
        end
        
        --Move the closest hand into position, and the other hand out of the way.
        if self.playerRight then
            self.rHandPos = Vector(playerActor.Pos.X, self.bossPos.Y + math.cos(((playerActor.Pos.X - self.bossPos.X) / 320) * math.pi * 0.5) * 60);
            self:SetWristAngle(true, SceneMan:ShortestDistance(self.rWrist.Pos, playerActor.Pos, false).AbsRadAngle);
            self.lHandPos = self.lArmPartA.Pos + Vector(-self.segmentLength, self.segmentLength * 0.5);
        else
            self.lHandPos = Vector(playerActor.Pos.X, self.bossPos.Y + math.cos(((self.bossPos.X - playerActor.Pos.X) / 320) * math.pi * 0.5) * 60)
            self:SetWristAngle(false, SceneMan:ShortestDistance(self.lWrist.Pos, playerActor.Pos, false).AbsRadAngle);
            self.rHandPos = self.rArmPartA.Pos + Vector(self.segmentLength, self.segmentLength * 0.5);
        end
    end

    --Make the hands glow.
    if self.animEvent >= 5 and self.animEvent <= 6 then
        if math.random() > 0.7 then
            local glowA = CreateMOPixel("Prison Escape Ep3.rte/Laser Hand Glow");
            glowA.Pos = self.rWrist.Pos;
            MovableMan:AddParticle(glowA);
        end
        
        if math.random() > 0.7 then
            local glowB = CreateMOPixel("Prison Escape Ep3.rte/Laser Hand Glow");
            glowB.Pos = self.lWrist.Pos;
            MovableMan:AddParticle(glowB);
        end
        
        --Cook actors caught in the charge.
        for actor in MovableMan.Actors do
            if actor.GetsHitByMOs then
                if (SceneMan:ShortestDistance(actor.Pos, self.rWrist.Pos, false).Magnitude < 60 and actor.Pos.X > self.rWrist.Pos.X)
                or (SceneMan:ShortestDistance(actor.Pos, self.lWrist.Pos, false).Magnitude < 60 and actor.Pos.X < self.lWrist.Pos.X) then
                    actor.Health = actor.Health - 1;
                end
            end
        end
    end
end

function PE3BossAnimation5_0(self)
    --Which side the player is on.
    self.playerRight = true;
    
    --Flag the hands to change orientation.
    self.sideSwitched = true;
    
    --Timer for side switching (so the boss doesn't jitter in the center).
    self.switchTimer = Timer();
    
    --Whether to ignore the switch timer.
    self.ignoreSwitchTimer = true;
    
    --Heave.
    self:SetHeave(true);
    
    --The concrete sprayer sound.
    self.spraySound = CreateAEmitter("Prison Escape Ep3.rte/Sprayer Sound Emitter");
    self.spraySound.Pos = self.bossPos;
    MovableMan:AddParticle(self.spraySound);
    self.spraySound:EnableEmission(false);
    
    --Don't get hit by the concrete.
    self.upperBody.GetsHitByMOs = false;
    
    --Flash the eyes.
    self:FlashEyes();
    
    self:NextBossEvent(true);
end
    
function PE3BossAnimation5_1(self)
    if self.animTimer:IsPastSimMS(1500) then
        self.spraySound:EnableEmission(true);
        
        --Make the hands move faster.
        self.rArmPartALerpSpeed = 0.2;
        self.rArmPartBLerpSpeed = 0.2;
        self.rWristLerpSpeed = 0.2;
        self.lArmPartALerpSpeed = 0.2;
        self.lArmPartBLerpSpeed = 0.2;
        self.lWristLerpSpeed = 0.2;
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation5_2(self)
    --Choose which hand to use.
    local sprayPos, wristAngle;
    if self.playerRight then
        sprayPos = self.rWrist.Pos;
        wristAngle = self.rWrist.RotAngle;
    else
        sprayPos = self.lWrist.Pos;
        wristAngle = self.lWrist.RotAngle;
    end

    --Spray concrete.
    for i = 0, 5 do
        local name = "Prison Escape Ep3.rte/Particle Concrete ";
        if math.random() > 0.6 then
            name = name .. "Dark";
        else
            name = name .. "Light";
        end
        local part = CreateMOPixel(name);
        part.Pos = sprayPos + Vector(5, -15):RadRotate(wristAngle);
        part.Vel = Vector(math.random(20, 30), math.random() * 10 - 5):RadRotate(wristAngle);
        MovableMan:AddParticle(part);
    end
    for i = 0, 5 do
        local name = "Prison Escape Ep3.rte/Particle Concrete ";
        if math.random() > 0.6 then
            name = name .. "Dark";
        else
            name = name .. "Light";
        end
        local part = CreateMOPixel(name);
        part.Pos = sprayPos;
        part.Vel = Vector(math.random(20, 30), math.random() * 5 - 2.5):RadRotate(wristAngle);
        MovableMan:AddParticle(part);
    end
    for i = 0, 5 do
        local name = "Prison Escape Ep3.rte/Particle Concrete ";
        if math.random() > 0.6 then
            name = name .. "Dark";
        else
            name = name .. "Light";
        end
        local part = CreateMOPixel(name);
        part.Pos = sprayPos + Vector(5, 15):RadRotate(wristAngle);
        part.Vel = Vector(math.random(20, 30), math.random() * 5 - 2.5):RadRotate(wristAngle);
        MovableMan:AddParticle(part);
    end
        
    --Only do the following if the player can be reached.
    if not SceneMan:CastStrengthRay(sprayPos, SceneMan:ShortestDistance(sprayPos, playerActor.Pos, false), 0, Vector(), 5, 0, false) and playerActor.Pos.Y > sprayPos.Y then
        --Apply force to the player.
        playerActor.Vel = playerActor.Vel + Vector(0.8, 0):RadRotate(wristAngle);
    end
    
    --Keep the player above the underground tunnel (he can glitch through when stuck in concrete).
    if playerActor.Pos.Y > 516 then
        playerActor.Pos.Y = 516;
    end
    
    --Stop spraying when the concrete reaches a certain level or has been sprayed for long enough.
    if SceneMan:CastStrengthRay(self.bossPos + Vector(-260, 120), Vector(520, 0), 0, Vector(), 3, 0, false) or self.animTimer:IsPastSimMS(15000) then
        self.spraySound.ToDelete = true;
        self.spraySound = nil;
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation5_3(self)
    self:ResetLerpSpeeds();
    self:SetHeave(false);
    
    --Concrete is done spraying, so being hit is okay again.
    self.upperBody.GetsHitByMOs = true;

    --Move the hands into place.
    self.rIdealClawOpen = self.maxClawOpen;
    self.rHandPos = self.bossPos + Vector(280, 160);
    self:SetWristAngle(true, math.pi);
    self.lIdealClawOpen = self.maxClawOpen;
    self.lHandPos = self.bossPos + Vector(-280, 160);
    self:SetWristAngle(false, 0);
    
    --Flash the eyes.
    self:FlashEyes();
    
    self:NextBossEvent(true);
end
    
function PE3BossAnimation5_4(self)
    --Charge the laser.
    if self.animTimer:IsPastSimMS(500 * self.waitX) then
        local chargeSound = CreateAEmitter("Prison Escape Ep3.rte/Laser Charge Sound Emitter");
        chargeSound.Pos = Vector(self.bossPos.X, self.rWrist.Pos.Y);
        MovableMan:AddParticle(chargeSound);
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation5_5(self)
    --Create the laser effect.
    if self.animTimer:IsPastSimMS(1400 * self.waitX) then
        local laserSound = CreateAEmitter("Prison Escape Ep3.rte/Laser Sound Emitter");
        laserSound.Pos = Vector(self.bossPos.X, self.rWrist.Pos.Y);
        MovableMan:AddParticle(laserSound);
        
        --How far from the edge to remove pixels.
        self.edgeDistance = 0;
        
        self:NextBossEvent(true);
    end
end
    
--Make the laser glow and erase pixels.
function PE3BossAnimation5_6(self)
    if self.animEvent == 6 then
        --Erase pixels on the right side.
        for x = self.rWrist.Pos.X - (self.edgeDistance + 2), self.rWrist.Pos.X - self.edgeDistance do
            for y = self.rWrist.Pos.Y - 32, self.rWrist.Pos.Y + 32 do
                local pos = Vector(x, y);
                ErasePixel(pos);
            end
        end
        
        --Erase pixels on the left side.
        for x = self.lWrist.Pos.X + (self.edgeDistance - 2), self.lWrist.Pos.X + self.edgeDistance do
            for y = self.lWrist.Pos.Y - 32, self.lWrist.Pos.Y + 32 do
                local pos = Vector(x, y);
                ErasePixel(pos);
            end
        end
        
        --Erase actors if they're caught in the field.
        for actor in MovableMan.Actors do
            if actor.GetsHitByMOs then
                if (actor.Pos.X > self.rWrist.Pos.X - self.edgeDistance - 5 and actor.Pos.X < self.rWrist.Pos.X - self.edgeDistance + 5
                or actor.Pos.X > self.lWrist.Pos.X + self.edgeDistance - 5 and actor.Pos.X < self.lWrist.Pos.X + self.edgeDistance + 5)
                and actor.Pos.Y > self.rWrist.Pos.Y - 40 and actor.Pos.Y < self.rWrist.Pos.Y + 40 then
                    --Kill the actor.
                    actor.Health = -100;
                    actor.Lifetime = actor.Age + 1000;
                    actor.PinStrength = 999999;
                    actor:FlashWhite(5000);
                    
                    --Add the fizzling effect.
                    local fizzle = CreateAEmitter("Prison Escape Ep3.rte/Fizzling Emitter");
                    fizzle.Pos = actor.Pos;
                    MovableMan:AddParticle(fizzle);
                end
            end
        end
        
        --Stop the column once it's past the center.
        if self.rWrist.Pos.X - self.edgeDistance < self.bossPos.X then
            self:NextBossEvent(true);
        end
        
        --Move the column inward.
        self.edgeDistance = self.edgeDistance + 3;
    end
end

--Return to idle.
function PE3BossAnimation5_7(self)
    if self.animTimer:IsPastSimMS(1500) then
        self:StartBossAnimation(self.animMode.IDLE);
    end
end

--Surprise people who are flying around in the air and smash them out of the air.
-- 6 (AIRSMASH)
function PE3BossAnimation6(self)

end

function PE3BossAnimation6_0(self)
    --Make the hands move faster.
    self.rArmPartALerpSpeed = 0.3;
    self.rArmPartBLerpSpeed = 0.3;
    self.lArmPartALerpSpeed = 0.3;
    self.lArmPartBLerpSpeed = 0.3;
    
    --Heave.
    self:SetHeave(true);
    
    --Flash the eyes.
    self:FlashEyes();
    
    --Flip the arms.
    self.rFlipArm = true;
    self.rHandPos = self.rHandPos + Vector(50, -50);
    self.lFlipArm = true;
    self.lHandPos = self.lHandPos + Vector(-50, -50);
    
    self:NextBossEvent(true);
end
    
function PE3BossAnimation6_1(self)
    if self.animTimer:IsPastSimMS(300 * self.waitX) then
        --Stop heaving.
        self:SetHeave(false);
    
        --Smash the player.
        if playerActor.Pos.X > self.bossPos.X then
            self.rHandPos = playerActor.Pos + playerActor.Vel;
            self:SmashEffect(self.rHandPos, "Small");
        else
            self.lHandPos = playerActor.Pos + playerActor.Vel;
            self:SmashEffect(self.lHandPos, "Small");
        end
        playerActor.Vel = Vector(0, -25);
		GibActor(playerActor);
        
        --Laugh. You probably just scared the crap out of the player.
        local laughSound = CreateAEmitter("Prison Escape Ep3.rte/Laugh Sound Emitter");
        laughSound.Pos = self.bossPos;
        MovableMan:AddParticle(laughSound);
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation6_2(self)
    if self.animTimer:IsPastSimMS(600 * self.waitX) then
        --Return to idling.
        self:StartBossAnimation(self.animMode.IDLE);
    end
end

-- 7 (CLAP)
--Puts hands against the ground and claps them together.
function PE3BossAnimation7(self)

end

function PE3BossAnimation7_0(self)
    --Move the hands into place.
    self.rIdealClawOpen = self.maxClawOpen;
    self.rHandPos = self.bossPos + Vector(280, 140);
    self:SetWristAngle(true, math.pi);
    self.lIdealClawOpen = self.maxClawOpen;
    self.lHandPos = self.bossPos + Vector(-280, 140);
    self:SetWristAngle(false, 0);
    
    self:NextBossEvent(true);
end
    
function PE3BossAnimation7_1(self)
    if self.animTimer:IsPastSimMS(2300 * self.waitX) then
        --Flash the eyes.
        self:FlashEyes();
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation7_2(self)
    if self.animTimer:IsPastSimMS(300 * self.waitX) then
        --Make the hands move faster.
        self.rArmPartALerpSpeed = 0.4;
        self.rArmPartBLerpSpeed = 0.4;
        self.lArmPartALerpSpeed = 0.4;
        self.lArmPartBLerpSpeed = 0.4;
        
        --Clap the hands together.
        self.rHandCrushVel = Vector(0, 0);
        self.lHandCrushVel = Vector(0, 0);
        self.rHandCrush = true;
        self.lHandCrush = true;
        self.rHandPos.X = self.bossPos.X - 12;
        self.lHandPos.X = self.bossPos.X + 12;
        
        --Smash actors manually, as the hands move very quickly.
        for actor in MovableMan.Actors do
            if actor.GetsHitByMOs then
                if actor.Pos.X > self.lWrist.Pos.X and actor.Pos.X < self.rWrist.Pos.X
                and actor.Pos.Y > self.lWrist.Pos.Y - 40 and actor.Pos.Y < self.lWrist.Pos.Y + 40 then
                    actor.Pos.X = self.bossPos.X;
                    GibActor(actor);
                end
            end
        end
        
        --Make a smash effect.
        self:SmashEffect(self.bossPos + Vector(0, 140), "Small");
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation7_3(self)
    --Stop crushing.
    if self.animTimer:IsPastSimMS(200) then
        self.rHandCrush = false;
        self.lHandCrush = false;
        
        self:NextBossEvent(true);
    end
end
   
function PE3BossAnimation7_4(self)
    --Repeat.
    if self.animTimer:IsPastSimMS(600 * self.waitX) then
        --Move the hands into place.
        self.rHandPos = self.bossPos + Vector(280, 140);
        self.lHandPos = self.bossPos + Vector(-280, 140);
        
        self:NextBossEvent(true);
    end
end

function PE3BossAnimation7_5(self)
    if self.animTimer:IsPastSimMS(300 * self.waitX) then
        --Flash the eyes.
        self:FlashEyes();
        
        self:NextBossEvent(true);
    end
end

function PE3BossAnimation7_6(self)
    if self.animTimer:IsPastSimMS(300 * self.waitX) then
        --Clap the hands together.
        self.rHandCrushVel = Vector(0, 0);
        self.lHandCrushVel = Vector(0, 0);
        self.rHandCrush = true;
        self.lHandCrush = true;
        self.rHandPos.X = self.bossPos.X - 12;
        self.lHandPos.X = self.bossPos.X + 12;
        
        --Smash actors manually, as the hands move very quickly.
        for actor in MovableMan.Actors do
            if actor.GetsHitByMOs then
                if actor.Pos.X > self.lWrist.Pos.X and actor.Pos.X < self.rWrist.Pos.X
                and actor.Pos.Y > self.lWrist.Pos.Y - 32 and actor.Pos.Y < self.lWrist.Pos.Y + 32 then
                    actor.Pos.X = self.bossPos.X;
                    GibActor(actor);
                end
            end
        end
        
        --Make a smash effect.
        self:SmashEffect(self.bossPos + Vector(0, 140), "Small");
        
        self:NextBossEvent(true);
    end
end

function PE3BossAnimation7_7(self)
    --Stop crushing.
    if self.animTimer:IsPastSimMS(200 * self.waitX) then
        self.rHandCrush = false;
        self.lHandCrush = false;
        
        self:NextBossEvent(true);
    end
end

function PE3BossAnimation7_8(self)
    --Repeat one more time.
    if self.animTimer:IsPastSimMS(600 * self.waitX) then
        --Move the hands into place.
        self.rHandPos = self.bossPos + Vector(280, 140);
        self.lHandPos = self.bossPos + Vector(-280, 140);
        
        self:NextBossEvent(true);
    end
end

function PE3BossAnimation7_9(self)
    if self.animTimer:IsPastSimMS(1800 * self.waitX) then
        --Flash the eyes.
        self:FlashEyes();
        
        self:NextBossEvent(true);
    end
end

function PE3BossAnimation7_10(self)
    if self.animTimer:IsPastSimMS(300 * self.waitX) then
        --Clap the hands together.
        self.rHandCrushVel = Vector(0, 0);
        self.lHandCrushVel = Vector(0, 0);
        self.rHandCrush = true;
        self.lHandCrush = true;
        self.rHandPos.X = self.bossPos.X - 12;
        self.lHandPos.X = self.bossPos.X + 12;
        
        --Smash actors manually, as the hands move very quickly.
        for actor in MovableMan.Actors do
            if actor.GetsHitByMOs then
                if actor.Pos.X > self.lWrist.Pos.X and actor.Pos.X < self.rWrist.Pos.X
                and actor.Pos.Y > self.lWrist.Pos.Y - 32 and actor.Pos.Y < self.lWrist.Pos.Y + 32 then
                    actor.Pos.X = self.bossPos.X;
                    GibActor(actor);
                end
            end
        end
        
        --Make a smash effect.
        self:SmashEffect(self.bossPos + Vector(0, 140), "Small");
        
        self:NextBossEvent(true);
    end
end

function PE3BossAnimation7_11(self)
    --Stop crushing.
    if self.animTimer:IsPastSimMS(200 * self.waitX) then
        self.rHandCrush = false;
        self.lHandCrush = false;
        
        self:FlashEyes();
        
        self:NextBossEvent(true);
    end
end

function PE3BossAnimation7_12(self)
    --Make it a double-clap!
    if self.animTimer:IsPastSimMS(50 * self.waitX) then
        --Move the hands into place.
        self.rHandPos = self.bossPos + Vector(280, 140);
        self.lHandPos = self.bossPos + Vector(-280, 140);
        
        self:NextBossEvent(true);
    end
end

function PE3BossAnimation7_13(self)
    if self.animTimer:IsPastSimMS(250 * self.waitX) then
        --Clap the hands together.
        self.rHandCrushVel = Vector(0, 0);
        self.lHandCrushVel = Vector(0, 0);
        self.rHandCrush = true;
        self.lHandCrush = true;
        self.rHandPos.X = self.bossPos.X - 12;
        self.lHandPos.X = self.bossPos.X + 12;
        
        --Smash actors manually, as the hands move very quickly.
        for actor in MovableMan.Actors do
            if actor.GetsHitByMOs then
                if actor.Pos.X > self.lWrist.Pos.X and actor.Pos.X < self.rWrist.Pos.X
                and actor.Pos.Y > self.lWrist.Pos.Y - 32 and actor.Pos.Y < self.lWrist.Pos.Y + 32 then
                    actor.Pos.X = self.bossPos.X;
                    GibActor(actor);
                end
            end
        end
        
        --Make a smash effect.
        self:SmashEffect(self.bossPos + Vector(0, 140), "Small");
        
        self:NextBossEvent(true);
    end
end

function PE3BossAnimation7_14(self)
    --Stop crushing.
    if self.animTimer:IsPastSimMS(200 * self.waitX) then
        self.rHandCrush = false;
        self.lHandCrush = false;
        
        self:NextBossEvent(true);
    end
end

function PE3BossAnimation7_15(self)
    --Return to idle.
    if self.animTimer:IsPastSimMS(1000 * self.waitX) then
        self:StartBossAnimation(self.animMode.IDLE);
    end
end

-- 8 (VACUUM)
--Tries to suck the player into a vacuum on either side.
function PE3BossAnimation8(self)
    --Move the hand to the player's position.
    if self.animEvent <= 5 then
        self.rHandPos = Vector(self.bossPos.X + 280, playerActor.Pos.Y + 10);
    end
    
    --Vaccum stuff.
    if self.animEvent == 3 or self.animEvent == 4 then
        --Suck things into the vacuum.
        for actor in MovableMan.Actors do
            if actor.GetsHitByMOs then
                local offset = SceneMan:ShortestDistance(actor.Pos, self.rWrist.Pos, false);
                local strength = ((640 - offset.Magnitude) / 640) * 0.8;
                if strength < 0 then
                    strength = 0;
                end
                actor.Vel = actor.Vel + offset.Normalized * strength + Vector(0, -0.2);
            end
        end
        
        --Make a smoke effect.
        local effect = CreateMOSParticle("Prison Escape Ep3.rte/Smoke Ball 1 No-Hit");
        effect.Pos = self.rWrist.Pos + Vector(-75 + math.random() * 20, math.random() * 80 - 40);
        effect.Vel = SceneMan:ShortestDistance(effect.Pos, self.rWrist.Pos, false).Normalized * (math.random() * 15 + 3);
        MovableMan:AddParticle(effect);
        
        --Finish vacuuming. self.waitX is divided to make this last less time in easier modes.
        if self.animTimer:IsPastSimMS(5000 / self.waitX) then
            self.vacuumSound:EnableEmission(false);
            
            self:NextBossEvent(true);
        end
    end
    
    --Erase actors that enter the hand.
    if self.animEvent >= 3 and self.animEvent <= 5 then
        for actor in MovableMan.Actors do
            if actor.GetsHitByMOs then
                if SceneMan:ShortestDistance(actor.Pos, self.rWrist.Pos, false).Magnitude < 30 and actor.Pos.X < self.rWrist.Pos.X then
                    --Close the hand and erase the actor.
                    actor.Vel = Vector(0, 0);
                    actor.ToDelete = true;
                    self.rIdealClawOpen = self.minClawOpen;
                    self.vacuumSound:EnableEmission(false);
                    
                    --Play the sucking up sound.
                    local suckSound = CreateAEmitter("Prison Escape Ep3.rte/Sucked Up Sound Emitter");
                    suckSound.Pos = self.bossPos;
                    MovableMan:AddParticle(suckSound);
                    
                    self.animEvent = 5;
                    self.animTimer:Reset();
                    
                    break;
                end
            end
        end
    end
    
    --Move the hand to the player's position.
    if self.animEvent >= 5 and self.animEvent <= 10 then
        self.lHandPos = Vector(self.bossPos.X - 280, playerActor.Pos.Y + 10);
    end
    
    if self.animEvent == 8 or self.animEvent == 9 then
        --Suck things into the vacuum.
        for actor in MovableMan.Actors do
            if actor.GetsHitByMOs then
                local offset = SceneMan:ShortestDistance(actor.Pos, self.lWrist.Pos, false);
                local strength = ((640 - offset.Magnitude) / 640) * 0.8;
                if strength < 0 then
                    strength = 0;
                end
                actor.Vel = actor.Vel + offset.Normalized * strength + Vector(0, -0.2);
            end
        end
        
        --Make a smoke effect.
        local effect = CreateMOSParticle("Prison Escape Ep3.rte/Smoke Ball 1 No-Hit");
        effect.Pos = self.lWrist.Pos + Vector(75 + math.random() * 20, math.random() * 80 - 40);
        effect.Vel = SceneMan:ShortestDistance(effect.Pos, self.lWrist.Pos, false).Normalized * (math.random() * 15 + 3);
        MovableMan:AddParticle(effect);
        
        --Finish vacuuming. self.waitX is divided to make this last less time in easier modes.
        if self.animTimer:IsPastSimMS(5000 / self.waitX) then
            self.vacuumSound:EnableEmission(false);
            
            self:NextBossEvent(true);
        end
    end
    
    --Erase actors that enter the hand.
    if self.animEvent >= 8 and self.animEvent <= 10 then
        for actor in MovableMan.Actors do
            if actor.GetsHitByMOs then
                if SceneMan:ShortestDistance(actor.Pos, self.lWrist.Pos, false).Magnitude < 30 and actor.Pos.X > self.lWrist.Pos.X then
                    --Close the hand and erase the actor.
                    actor.Vel = Vector(0, 0);
                    actor.ToDelete = true;
                    self.lIdealClawOpen = self.minClawOpen;
                    self.vacuumSound:EnableEmission(false);
                    
                    --Play the sucking up sound.
                    local suckSound = CreateAEmitter("Prison Escape Ep3.rte/Sucked Up Sound Emitter");
                    suckSound.Pos = self.bossPos;
                    MovableMan:AddParticle(suckSound);
                    
                    self.animEvent = 10;
                    self.animTimer:Reset();
                    
                    break;
                end
            end
        end
    end
end

function PE3BossAnimation8_0(self)
    --Move the hand into place.
    self.rIdealClawOpen = self.maxClawOpen;
    self:SetWristAngle(true, math.pi);
    
    self:NextBossEvent(true);
end
    
function PE3BossAnimation8_1(self)
    if self.animTimer:IsPastSimMS(2200 * self.waitX) then
        --Flash the eyes as a warning.
        self:FlashEyes();
        
        self:NextBossEvent(true);
    end
end
    
--Start the vacuum.
function PE3BossAnimation8_2(self)
    if self.animTimer:IsPastSimMS(300 * self.waitX) then
        self.vacuumSound = CreateAEmitter("Prison Escape Ep3.rte/Vacuum Start Sound Emitter");
        self.vacuumSound.Pos = self.bossPos;
        MovableMan:AddParticle(self.vacuumSound);
    
        self:NextBossEvent(true);
    end
end
    
--Start the looping sound.
function PE3BossAnimation8_3(self)
    if self.animTimer:IsPastSimMS(1200) then
        self.vacuumSound = CreateAEmitter("Prison Escape Ep3.rte/Vacuum Sound Emitter");
        self.vacuumSound.Pos = self.bossPos;
        MovableMan:AddParticle(self.vacuumSound);
    
        self:NextBossEvent(true);
    end
end

function PE3BossAnimation8_4(self)

end

function PE3BossAnimation8_5(self)
    --Switch hands.
    if self.animTimer:IsPastSimMS(1000 * self.waitX) then
        --Move the right hand back to its default position.
        self.rHandPos = self.rArmPartA.Pos + Vector(self.segmentLength, self.segmentLength * 0.5);
        self.rIdealClawOpen = self.minClawOpen;
        self:SetWristAngle(true, nil);
        
        --Move the left hand down.
        self.lIdealClawOpen = self.maxClawOpen;
        self:SetWristAngle(false, 0);
        
        self:NextBossEvent(true);
    end
end

function PE3BossAnimation8_6(self)
    --Flash the eyes as a warning.
    if self.animTimer:IsPastSimMS(2200 * self.waitX) then
        self:FlashEyes();
        
        self:NextBossEvent(true);
    end
end

function PE3BossAnimation8_7(self)
    --Start the vacuum sound.
    if self.animTimer:IsPastSimMS(300 * self.waitX) then
        self.vacuumSound = CreateAEmitter("Prison Escape Ep3.rte/Vacuum Start Sound Emitter");
        self.vacuumSound.Pos = self.bossPos;
        MovableMan:AddParticle(self.vacuumSound);
    
        self:NextBossEvent(true);
    end
end

function PE3BossAnimation8_8(self)
    --Start the looping sound.
    if self.animTimer:IsPastSimMS(1200) then
        self.vacuumSound = CreateAEmitter("Prison Escape Ep3.rte/Vacuum Sound Emitter");
        self.vacuumSound.Pos = self.bossPos;
        MovableMan:AddParticle(self.vacuumSound);
    
        self:NextBossEvent(true);
    end
end

function PE3BossAnimation8_9(self)

end
    
function PE3BossAnimation8_10(self)
    --Idle.
    if self.animTimer:IsPastSimMS(1000 * self.waitX) then
        self.vacuumSound = nil;
        self:StartBossAnimation(self.animMode.IDLE);
    end
end

-- 9 (CHICKENPECK)
--Moves the hand over the player, then smashes down.
function PE3BossAnimation9(self)

end

function PE3BossAnimation9_0(self)
    --Which side the player is on.
    self.playerRight = true;
    
    --Flag the hands to change orientation.
    self.sideSwitched = true;
    
    --Timer for side switching (so the boss doesn't jitter in the center).
    self.switchTimer = Timer();
    
    --Whether to ignore the switch timer.
    self.ignoreSwitchTimer = true;
    
    --Close the claws.
    self.rIdealClawOpen = self.minClawOpen;
    self.lIdealClawOpen = self.minClawOpen;
    
    --Heave.
    self:SetHeave(true);
    
    self:NextBossEvent(true);
end

function PE3BossAnimation9_1(self)
    --Determine which side the player is on.
    if self.switchTimer:IsPastSimMS(1000) or self.ignoreSwitchTimer then
        if playerActor.Pos.X < self.bossPos.X then
            if self.playerRight then
                self.playerRight = false;
                self.sideSwitched = true;
            end
        else
            if not self.playerRight then
                self.playerRight = true;
                self.sideSwitched = true;
            end
        end
    end
    
    --Orient the hands when the side has been switched.
    if self.sideSwitched then
        if self.playerRight then
            self:SetWristAngle(false, nil);
            self:SetWristAngle(true, math.pi * 1.5);
            
            --Move the arm faster.
            self:ResetLerpSpeeds();
            self.rArmPartALerpSpeed = 0.2;
            self.rArmPartBLerpSpeed = 0.2;
        else
            self:SetWristAngle(true, nil);
            self:SetWristAngle(false, math.pi * 1.5);
            
            --Move the arm faster.
            self:ResetLerpSpeeds();
            self.lArmPartALerpSpeed = 0.2;
            self.lArmPartBLerpSpeed = 0.2;
        end
        
        self.sideSwitched = false;
        self.ignoreSwitchTimer = false;
        self.switchTimer:Reset();
    end
    
    --Move the closest hand into position, and the other hand out of the way.
    local distMod = math.cos(((playerActor.Pos.X - self.bossPos.X) / 320) * math.pi * 0.5);
    if self.playerRight then
        self.rHandPos = Vector(playerActor.Pos.X - distMod * 25, self.bossPos.Y + distMod * 30);
        self.lHandPos = self.lArmPartA.Pos + Vector(-self.segmentLength, self.segmentLength * 0.25);
    else
        self.lHandPos = Vector(playerActor.Pos.X + distMod * 25, self.bossPos.Y + distMod * 30)
        self.rHandPos = self.rArmPartA.Pos + Vector(self.segmentLength, self.segmentLength * 0.25);
    end
    
    if self.animTimer:IsPastSimMS(3000 * self.waitX) then
        self:SetHeave(false);
        self:FlashEyes();
        
        self.rArmPartALerpSpeed = 0;
        self.rArmPartBLerpSpeed = 0;
        self.rWristLerpSpeed = 0;
        self.lArmPartALerpSpeed = 0;
        self.lArmPartBLerpSpeed = 0;
        self.lWristLerpSpeed = 0;
        
        self:NextBossEvent(true);
    end
end

--Smash the hand down.
function PE3BossAnimation9_2(self)
    if self.animTimer:IsPastSimMS(400 * self.waitX) then
        if self.playerRight then
            self.rArmPartALerpSpeed = 0.5;
            self.rArmPartBLerpSpeed = 0.5;
            self.rHandPos = Vector(self.rWrist.Pos.X, self.bossPos.Y + 160);
            self:SmashEffect(SceneMan:MovePointToGround(Vector(self.rWrist.Pos.X, 0), 5, 2), "Small");
            self.rHandCrush = true;
        else
            self.lArmPartALerpSpeed = 0.5;
            self.lArmPartBLerpSpeed = 0.5;
            self.lHandPos = Vector(self.lWrist.Pos.X, self.bossPos.Y + 160);
            self:SmashEffect(SceneMan:MovePointToGround(Vector(self.lWrist.Pos.X, 0), 5, 2), "Small");
            self.lHandCrush = true;
        end
        
        self:NextBossEvent(true);
    end
end

--Disable the hand crushing once it hits the ground.
function PE3BossAnimation9_3(self)
    if self.animTimer:IsPastSimMS(100) then
        if self.playerRight then
            self.rHandCrush = false;
        else
            self.lHandCrush = false;
        end
        
        self:NextBossEvent(true);
    end
end

--Idle.
function PE3BossAnimation9_4(self)
    if self.animTimer:IsPastSimMS(500) then
        self:StartBossAnimation(self.animMode.IDLE);
    end
end

-- 10 (GROUNDFLAMES)
--Fires a wide laser from the eyes which sets the ground on fire.
function PE3BossAnimation10(self)

end

function PE3BossAnimation10_0(self)
    --Stop heaving.
    self:SetHeave(false);

    --Charge the laser.
    local chargeSound = CreateAEmitter("Prison Escape Ep3.rte/Laser Charge Sound Emitter");
    chargeSound.Pos = Vector(self.bossPos.X, self.rWrist.Pos.Y);
    MovableMan:AddParticle(chargeSound);
    
    self:NextBossEvent(true);
end
    
--Make the eyes glow.
function PE3BossAnimation10_1(self)
    if math.random() > 0.8 then
        local eyeEffectA = CreateMOPixel("Prison Escape Ep3.rte/Boss Eye Charge Glow");
        eyeEffectA.Pos = self.upperBody.Pos + Vector(-6, -32);
        MovableMan:AddParticle(eyeEffectA);
        local eyeEffectB = CreateMOPixel("Prison Escape Ep3.rte/Boss Eye Charge Glow");
        eyeEffectB.Pos = self.upperBody.Pos + Vector(6, -32);
        MovableMan:AddParticle(eyeEffectB);
    end
    
    --Fire.
    if self.animTimer:IsPastSimMS(2000 * self.waitX) then
        local laserSound = CreateAEmitter("Prison Escape Ep3.rte/Laser Sound Emitter");
        laserSound.Pos = Vector(self.bossPos.X, self.rWrist.Pos.Y);
        MovableMan:AddParticle(laserSound);
    
        local laserEffect = CreateMOPixel("Prison Escape Ep3.rte/Wide Laser Glow");
        laserEffect.Pos = self.upperBody.Pos + Vector(0, 13);
        MovableMan:AddParticle(laserEffect);
        self:FlashEyes();
        
        self.burnSound = CreateAEmitter("Prison Escape Ep3.rte/Burn Sound Emitter");
        self.burnSound.Pos = self.bossPos;
        MovableMan:AddParticle(self.burnSound);
        
        --Set the ground on fire.
        local i = self.bossPos.X - 320;
        local distWithoutSmoke = 0;
        while i < self.bossPos.X + 320 do
            local addDist = math.random() * 12 + 4;
            i = i + addDist;
            distWithoutSmoke = distWithoutSmoke + addDist;
            local flame;
            if math.random() > 0.7 then
                flame = CreateMOSParticle("Prison Escape Ep3.rte/Flame 1 Hurt Short");
            else
                flame = CreateMOSParticle("Prison Escape Ep3.rte/Flame 2 Hurt Short");
            end
            
            flame.Pos = SceneMan:MovePointToGround(Vector(i, 0), 0, 0);
            MovableMan:AddParticle(flame);
            
            --Smoke.
            if math.random() < (distWithoutSmoke / 50)  then
                local smoke = CreateAEmitter("Prison Escape Ep3.rte/Flame Smoke Trail");
                smoke.Pos = flame.Pos + Vector(0, -3);
                MovableMan:AddParticle(smoke);
                
                distWithoutSmoke = 0;
            end
        end
        
        self:SetHeave(true);
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation10_2(self)
    if self.animTimer:IsPastSimMS(2500) then
        self.burnSound.Lifetime = self.burnSound.Age + 1500;
        self.burnSound:EnableEmission(false);
        self.burnSound = nil;
        
        self:NextBossEvent(true);
    end
end
    
function PE3BossAnimation10_3(self)
    --Idle.
    if self.animTimer:IsPastSimMS(1500 * self.waitX) then
        self:StartBossAnimation(self.animMode.IDLE);
    end
end

-- 11 (CONCRETEWAVE)
--Smashes the center, causing a ripple effect out to the edges.
function PE3BossAnimation11(self)

end

function PE3BossAnimation11_0(self)
    self:SetHeave(false);

    --Move the hands into place.
    self.rFlipArm = true;
    self.rHandPos = self.bossPos + Vector(15, -300);
    self.lFlipArm = true;
    self.lHandPos = self.bossPos + Vector(-15, -300);
    self:SetWristAngle(true, math.pi * 1.5);
    self:SetWristAngle(false, math.pi * 1.5);
    
    --Crushes will all be downward.
    self.rHandCrushVel = Vector(0, 25);
    self.lHandCrushVel = Vector(0, 25);
    
    self:NextBossEvent(true);
end
    
function PE3BossAnimation11_1(self)
    if self.animTimer:IsPastSimMS(2300 * self.waitX) then
        self:FlashEyes();
        
        self:NextBossEvent(true);
    end
end

function PE3BossAnimation11_2(self)
    if self.animTimer:IsPastSimMS(500 * self.waitX) then
        --Make the hands move faster.
        self.rArmPartALerpSpeed = 0.4;
        self.rArmPartBLerpSpeed = 0.4;
        self.lArmPartALerpSpeed = 0.4;
        self.lArmPartBLerpSpeed = 0.4;
        
        --Smash the hands down.
        self.rFlipArm = false;
        self.lFlipArm = false;
        self.rHandPos.Y = self.bossPos.Y + 160;
        self.lHandPos.Y = self.bossPos.Y + 160;
        
        --Smash actors manually, as the hands move very quickly and may phase past.
        for actor in MovableMan.Actors do
            if actor.GetsHitByMOs then
                if actor.Pos.X > self.bossPos.X - 40 and actor.Pos.X < self.bossPos.X + 40
                and actor.Pos.Y > self.bossPos.Y - 300 and actor.Pos.Y < self.bossPos.Y + 200 then
                    actor.Pos.X = self.bossPos.X;
                    GibActor(actor);
                end
            end
        end
        
        --Make smash effects.
        self:SmashEffect(Vector(self.rHandPos.X, self.bossPos.Y + 160), "Large");
        self:SmashEffect(Vector(self.lHandPos.X, self.bossPos.Y + 160), "Large");
        
        --How far from the center to make a smash.
        self.smashOffset = 32;
        
        self:NextBossEvent(true);
    end
end

function PE3BossAnimation11_3(self)
    --Smash outward. This repeats until the edge is hit.
    if self.animTimer:IsPastSimMS(100 * self.waitX) then
        --Smash on the right.
        local smashPosA = SceneMan:MovePointToGround(Vector(self.bossPos.X + self.smashOffset, 0), 5, 5);
        self:SmashEffect(smashPosA, "Tiny");
        for actor in MovableMan.Actors do
            if actor.GetsHitByMOs then
                if SceneMan:ShortestDistance(actor.Pos, smashPosA, false).Magnitude < 40 then
                    GibActor(actor);
                end
            end
        end
        
        --Smash on the left.
        local smashPosB = SceneMan:MovePointToGround(Vector(self.bossPos.X - self.smashOffset, 0), 5, 5);
        self:SmashEffect(smashPosB, "Tiny");
        for actor in MovableMan.Actors do
            if actor.GetsHitByMOs then
                if SceneMan:ShortestDistance(actor.Pos, smashPosB, false).Magnitude < 40 then
                    GibActor(actor);
                end
            end
        end
        
        --Move out further.
        self.smashOffset = self.smashOffset + 32;
        
        --If the smash is out of bounds, finish smashing. Otherwise, just rest the timer.
        if self.smashOffset > 320 then
            self:NextBossEvent(true);
        else
            self.animTimer:Reset();
        end
    end
end

function PE3BossAnimation11_4(self)
    --Return to idling.
    if self.animTimer:IsPastSimMS(1000 * self.waitX) then
        self:StartBossAnimation(self.animMode.IDLE);
    end
end


--Surprise people who are trying to escape by smashing them out of the air.
-- 12 (SIDESMASH)
function PE3BossAnimation12(self)

end

function PE3BossAnimation12_0(self)
    --Make the hands move faster.
    self.rArmPartALerpSpeed = 0.3;
    self.rArmPartBLerpSpeed = 0.3;
    self.lArmPartALerpSpeed = 0.3;
    self.lArmPartBLerpSpeed = 0.3;
    
    --Heave.
    self:SetHeave(true);
    
    --Flash the eyes.
    self:FlashEyes();
    
	--Smash the player.
	if playerActor.Pos.X > self.bossPos.X then
		self.rHandPos = playerActor.Pos + playerActor.Vel;
		self:SmashEffect(self.rHandPos, "Small");
	else
		self.lHandPos = playerActor.Pos + playerActor.Vel;
		self:SmashEffect(self.lHandPos, "Small");
	end
	playerActor.Vel = Vector(0, 0);
	GibActor(playerActor);
        
	--Laugh. You probably just scared the crap out of the player.
	local laughSound = CreateAEmitter("Prison Escape Ep3.rte/Laugh Sound Emitter");
	laughSound.Pos = self.bossPos;
	MovableMan:AddParticle(laughSound);
	
	self:Speak(self.borno, "Leaving so soon, Dafred? Come back and play!", 3000);
    
    self:NextBossEvent(true);
end
    
function PE3BossAnimation12_1(self)
    if self.animTimer:IsPastSimMS(600 * self.waitX) then
        --Return to idling.
        self:StartBossAnimation(self.animMode.IDLE);
    end
end

-- 13 (ENDSEQUENCE)
--Sequence that occurs when the boss runs out of health. Man, is this thing long.
function PE3BossAnimation13(self)
    --Shield the brain.
    if self.animEvent >= 1 and self.animEvent <= 4 then
        if self.playerRight then
            self.lHandPos = self.upperBody.Pos + Vector(20, 30);
        else
            self.rHandPos = self.upperBody.Pos + Vector(-20, 30);
        end
    end
    
    --Hold the player in the hand.
    if self.animEvent >= 3 and self.animEvent <= 22 then
        playerActor.PinStrength = 999999;
        playerActor.RotAngle = 0;
        playerActor.Vel = Vector(0, 0);
        playerActor.AngularVel = 0;
        if self.playerRight then
            playerActor.Pos = self.rWrist.Pos + Vector(35, 0):RadRotate(self.rWrist.RotAngle);
        else
            playerActor.Pos = self.lWrist.Pos + Vector(35, 0):RadRotate(self.lWrist.RotAngle);
        end
    end
    
    --Keep the player alive.
    if self.animEvent >= 22 then
        playerActor.Health = 100;
        playerActor.ToDelete = false;
    end
    
    --Vacuum.
    if self.animEvent >= 27 and self.animEvent <= 28 then
        local wristPos;
        if self.playerRight then
            wristPos = self.rWrist.Pos;
        else
            wristPos = self.lWrist.Pos;
        end
    
        --Suck things into the vacuum.
        for actor in MovableMan.Actors do
            if actor.GetsHitByMOs then
                local offset = SceneMan:ShortestDistance(actor.Pos, wristPos, false);
                local strength = ((640 - offset.Magnitude) / 640) * 0.35;
                if strength < 0 then
                    strength = 0;
                end
                actor.Vel = actor.Vel + offset.Normalized * strength;
                
                if SceneMan:ShortestDistance(actor.Pos, wristPos, false).Magnitude < 30 then
                    --Erase the actor.
                    actor.Vel = Vector(0, 0);
                    actor.ToDelete = true;
                    
                    --Play the sucking up sound.
                    local suckSound = CreateAEmitter("Prison Escape Ep3.rte/Sucked Up Sound Emitter");
                    suckSound.Pos = self.bossPos;
                    MovableMan:AddParticle(suckSound);
                end
            end
        end
        
        for p in MovableMan.Particles do
            if p.PresetName == "Particle RPC" then
                local offset = SceneMan:ShortestDistance(p.Pos, wristPos, false);
                local strength = ((640 - offset.Magnitude) / 640);
                if strength < 0 then
                    strength = 0;
                end
                p.Vel = p.Vel + offset.Normalized * strength;
                
                if SceneMan:ShortestDistance(p.Pos, wristPos, false).Magnitude < 30 then
                    --Suck up the rocket.
                    p.ToDelete = true;
                    
                    --Turn off the vacuum.
                    self.vacuumSound:EnableEmission(false);
                    self.vacuumSound.Lifetime = self.vacuumSound.Age + 5000;
                    self.vacuumSound = nil;
                    
                    --Make an awful sawing sound.
                    local sawSound = CreateAEmitter("Prison Escape Ep3.rte/Saw Sound Emitter");
                    sawSound.Pos = self.bossPos;
                    MovableMan:AddParticle(sawSound);
                    
                    --Stop the music.
                    AudioMan:ClearMusicQueue();
                    AudioMan:StopMusic();
                    
                    --Let Borno think he won.
                    self:Speak(self.borno, "GOTCHA!", 2000);
                    
                    --Pull the hand back.
                    if self.playerRight then
                        self:SetWristAngle(true, nil);
                        self.rIdealClawOpen = self.minClawOpen;
                        self.rHandPos = self.rArmPartA.Pos + Vector(self.segmentLength, self.segmentLength * 0.5);
                    else
                        self:SetWristAngle(false, nil);
                        self.lIdealClawOpen = self.minClawOpen;
                        self.lHandPos = self.lArmPartA.Pos + Vector(-self.segmentLength, self.segmentLength * 0.5);
                    end
                
                    self:NextBossEvent(true);
                end
            end
        end
        
        --Make a smoke effect.
        local effect = CreateMOSParticle("Prison Escape Ep3.rte/Smoke Ball 1 No-Hit");
        if self.playerRight then
            effect.Pos = wristPos + Vector(-75 + math.random() * 20, math.random() * 80 - 40);
        else
            effect.Pos = wristPos + Vector(75 - math.random() * 20, math.random() * 80 - 40);
        end
        effect.Vel = SceneMan:ShortestDistance(effect.Pos, wristPos, false).Normalized * (math.random() * 15 + 3);
        MovableMan:AddParticle(effect);
    end
    
    --Shake the screen while the robot gibs.
    if self.animEvent >= 31 then
        self:ShakeScreen(5, 5000);
    end
end

function PE3BossAnimation13_0(self)
    self:FlashEyes();
    
    --Play the more tense version of the song.
    AudioMan:ClearMusicQueue();
    AudioMan:PlayMusic("Prison Escape Ep3.rte/Sound/Music/TenseHavoc3.ogg", 0, -1);
    AudioMan:QueueMusicStream("Prison Escape Ep3.rte/Sound/Music/TenseHavocLoop.ogg");
    
    --Mark that this has been triggered.
    self.endSeqTriggered = true;
    
    --Break the panel off.
    self.panelOn = false;
    self.brainPanel:GibThis();
    
    --Remove the life bar.
    self:RemoveLifeBar();
    
    --Speed up hands.
    self.rArmPartALerpSpeed = 0.2;
    self.rArmPartBLerpSpeed = 0.2;
    self.rWristLerpSpeed = 0.5;
    self.lArmPartALerpSpeed = 0.2;
    self.lArmPartBLerpSpeed = 0.2;
    self.lWristLerpSpeed = 0.5;
    
    --Don't crush.
    self.rHandCrush = false;
    self.lHandCrush = false;
    
    --Don't flip the arms.
    self.rFlipArm = false;
    self.lFlipArm = false;
    
    --Heave faster.
    self.heaveSpeed = self.heaveSpeed * 3;
    
    --Find which side the player is on.
    self.playerRight = false;
    if playerActor.Pos.X > self.bossPos.X then
        self.playerRight = true;
    end
    
    --Shield the brain with the opposite hand.
    if self.playerRight then
        self:SetWristAngle(false, math.pi * 0.5);
        self.lPincerA.GetsHitByMOs = true;
        self.lPincerB.GetsHitByMOs = true;
        self.lIdealClawOpen = self.maxClawOpen;
    else
        self:SetWristAngle(true, math.pi * 0.5);
        self.rPincerA.GetsHitByMOs = true;
        self.rPincerB.GetsHitByMOs = true;
        self.rIdealClawOpen = self.maxClawOpen;
    end
    
    self:NextBossEvent(true);
end

--Grab the player.
function PE3BossAnimation13_1(self)
    if self.animTimer:IsPastSimMS(400) then
        if self.playerRight then
            self:SetWristAngle(true, SceneMan:ShortestDistance(self.rWrist.Pos, playerActor.Pos, false).AbsRadAngle);
            self.rIdealClawOpen = self.maxClawOpen;
            self.rHandPos = playerActor.Pos;
        else
            self:SetWristAngle(false, SceneMan:ShortestDistance(self.lWrist.Pos, playerActor.Pos, false).AbsRadAngle);
            self.lIdealClawOpen = self.maxClawOpen;
            self.lHandPos = playerActor.Pos;
        end
        
        self:NextBossEvent(true);
    end
end
    
--Bring the player to the air.
function PE3BossAnimation13_2(self)
    if self.animTimer:IsPastSimMS(150) then
        if self.playerRight then
            self.rIdealClawOpen = self.minClawOpen;
            self:SetWristAngle(true, math.pi * 0.5);
            self.rFlipArm = true;
            self.rHandPos = self.bossPos + Vector(self.segmentLength, -self.segmentLength * 0.5);
        else
            self.lIdealClawOpen = self.minClawOpen;
            self:SetWristAngle(false, math.pi * 0.5);
            self.lFlipArm = true;
            self.lHandPos = self.bossPos + Vector(-self.segmentLength, -self.segmentLength * 0.5);
        end
        
        self:NextBossEvent(true);
    end
end
    
--Let Borno speak.
function PE3BossAnimation13_3(self)
    if self.animTimer:IsPastSimMS(300) then
        self:Speak(self.borno, "Not this time, Ronin scum!", 3000);
        
        self:NextBossEvent(true);
    end
end

function PE3BossAnimation13_4(self)
    if self.animTimer:IsPastSimMS(3100) then
        --Stop heaving.
        self:SetHeave(false);
    
        --Flash the eyes.
        self:FlashEyes();
    
        --Yell.
        self:Speak(self.borno, "Die! Die! DIE!", 3000);
        
        --Speed up the hand and put it in position to smash. Move the other hand back to the idle spot.
        if self.playerRight then
            self.rArmPartALerpSpeed = 0.2;
            self.rArmPartBLerpSpeed = 0.2;
            self.rFlipArm = false;
            self.rHandPos = Vector(self.rHandPos.X + 40, self.rHandPos.Y + 40);
            self:SetWristAngle(true, math.pi * 1.5);
            
            self:SetWristAngle(false, nil);
            self.lIdealClawOpen = self.minClawOpen;
            self.lHandPos = self.lArmPartA.Pos + Vector(-self.segmentLength, self.segmentLength * 0.5);
        else
            self.lArmPartALerpSpeed = 0.2;
            self.lArmPartBLerpSpeed = 0.2;
            self.lFlipArm = false;
            self:SetWristAngle(false, math.pi * 1.5);
            self.lHandPos = Vector(self.lHandPos.X - 40, self.lHandPos.Y + 40);
            
            self:SetWristAngle(true, nil);
            self.rIdealClawOpen = self.minClawOpen;
            self.rHandPos = self.rArmPartA.Pos + Vector(self.segmentLength, self.segmentLength * 0.5);
        end
        
        self:NextBossEvent(true);
    end
end

--Make with the smashy-smashy.
function PE3BossAnimation13_5(self)
    if self.animTimer:IsPastSimMS(400) then
        --Smash.
        if self.playerRight then
            self.rArmPartALerpSpeed = 0.5;
            self.rArmPartBLerpSpeed = 0.5;
            self.rWristLerpSpeed = 0.5;
            self.rHandPos.Y = self.bossPos.Y + 160;
            self:SmashEffect(SceneMan:MovePointToGround(Vector(self.rHandPos.X, 0), 10, 0), "Small");
        else
            self.lArmPartALerpSpeed = 0.5;
            self.lArmPartBLerpSpeed = 0.5;
            self.lWristLerpSpeed = 0.5;
            self.lHandPos.Y = self.bossPos.Y + 160;
            self:SmashEffect(SceneMan:MovePointToGround(Vector(self.lHandPos.X, 0), 10, 0), "Small");
        end
        
        self:NextBossEvent(true);
    end
end

--Move the hand up.
function PE3BossAnimation13_6(self)
    if self.animTimer:IsPastSimMS(400) then
        self:FlashEyes();
        if self.playerRight then
            self.rHandPos.Y = self.bossPos.Y;
        else
            self.lHandPos.Y = self.bossPos.Y;
        end
        
        self:NextBossEvent(true);
    end
end

--Smash again.
function PE3BossAnimation13_7(self)
    if self.animTimer:IsPastSimMS(400) then 
        if self.playerRight then
            self.rHandPos.Y = self.bossPos.Y + 160;
            self:SmashEffect(SceneMan:MovePointToGround(Vector(self.rHandPos.X, 0), 10, 0), "Small");
        else
            self.lHandPos.Y = self.bossPos.Y + 160;
            self:SmashEffect(SceneMan:MovePointToGround(Vector(self.lHandPos.X, 0), 10, 0), "Small");
        end
        
        self:NextBossEvent(true);
    end
end

--Move the hand up.
function PE3BossAnimation13_8(self)
    if self.animTimer:IsPastSimMS(400) then
        self:FlashEyes();
        if self.playerRight then
            self.rHandPos.Y = self.bossPos.Y;
        else
            self.lHandPos.Y = self.bossPos.Y;
        end
        
        self:NextBossEvent(true);
    end
end
    
--Smash again.
function PE3BossAnimation13_9(self)
    if self.animTimer:IsPastSimMS(400) then 
        if self.playerRight then
            self.rHandPos.Y = self.bossPos.Y + 160;
            self:SmashEffect(SceneMan:MovePointToGround(Vector(self.rHandPos.X, 0), 10, 0), "Small");
        else
            self.lHandPos.Y = self.bossPos.Y + 160;
            self:SmashEffect(SceneMan:MovePointToGround(Vector(self.lHandPos.X, 0), 10, 0), "Small");
        end
        
        self:NextBossEvent(true);
    end
end

--Move the hand up.
function PE3BossAnimation13_10(self)
    if self.animTimer:IsPastSimMS(200) then
        self:FlashEyes();
        if self.playerRight then
            self.rHandPos.Y = self.bossPos.Y;
        else
            self.lHandPos.Y = self.bossPos.Y;
        end
        
        self:NextBossEvent(true);
    end
end
    
--Smash again.
function PE3BossAnimation13_11(self)
    if self.animTimer:IsPastSimMS(200) then 
        if self.playerRight then
            self.rHandPos.Y = self.bossPos.Y + 160;
            self:SmashEffect(SceneMan:MovePointToGround(Vector(self.rHandPos.X, 0), 10, 0), "Small");
        else
            self.lHandPos.Y = self.bossPos.Y + 160;
            self:SmashEffect(SceneMan:MovePointToGround(Vector(self.lHandPos.X, 0), 10, 0), "Small");
        end
        
        self:NextBossEvent(true);
    end
end
    
--Move the hand up.
function PE3BossAnimation13_12(self)
    if self.animTimer:IsPastSimMS(200) then
        self:FlashEyes();
        if self.playerRight then
            self.rHandPos.Y = self.bossPos.Y;
        else
            self.lHandPos.Y = self.bossPos.Y;
        end
        
        self:NextBossEvent(true);
    end
end
    
--Smash again.
function PE3BossAnimation13_13(self)
    if self.animTimer:IsPastSimMS(200) then 
        if self.playerRight then
            self.rHandPos.Y = self.bossPos.Y + 160;
            self:SmashEffect(SceneMan:MovePointToGround(Vector(self.rHandPos.X, 0), 10, 0), "Small");
        else
            self.lHandPos.Y = self.bossPos.Y + 160;
            self:SmashEffect(SceneMan:MovePointToGround(Vector(self.lHandPos.X, 0), 10, 0), "Small");
        end
        
        self:NextBossEvent(true);
    end
end
    
--Move the hand up.
function PE3BossAnimation13_14(self)
    if self.animTimer:IsPastSimMS(200) then
        self:FlashEyes();
        if self.playerRight then
            self.rHandPos.Y = self.bossPos.Y;
        else
            self.lHandPos.Y = self.bossPos.Y;
        end
        
        self:NextBossEvent(true);
    end
end
    
--Smash again.
function PE3BossAnimation13_15(self)
    if self.animTimer:IsPastSimMS(200) then 
        if self.playerRight then
            self.rHandPos.Y = self.bossPos.Y + 160;
            self:SmashEffect(SceneMan:MovePointToGround(Vector(self.rHandPos.X, 0), 10, 0), "Small");
        else
            self.lHandPos.Y = self.bossPos.Y + 160;
            self:SmashEffect(SceneMan:MovePointToGround(Vector(self.lHandPos.X, 0), 10, 0), "Small");
        end
        
        self:NextBossEvent(true);
    end
end
    
--Move the hand up.
function PE3BossAnimation13_16(self)
    if self.animTimer:IsPastSimMS(100) then
        self:FlashEyes();
        if self.playerRight then
            self.rHandPos.Y = self.bossPos.Y;
        else
            self.lHandPos.Y = self.bossPos.Y;
        end
        
        self:NextBossEvent(true);
    end
end
    
--Smash again.
function PE3BossAnimation13_17(self)
    if self.animTimer:IsPastSimMS(100) then 
        if self.playerRight then
            self.rHandPos.Y = self.bossPos.Y + 160;
            self:SmashEffect(SceneMan:MovePointToGround(Vector(self.rHandPos.X, 0), 10, 0), "Small");
        else
            self.lHandPos.Y = self.bossPos.Y + 160;
            self:SmashEffect(SceneMan:MovePointToGround(Vector(self.lHandPos.X, 0), 10, 0), "Small");
        end
        
        self:NextBossEvent(true);
    end
end
    
--Move the hand up.
function PE3BossAnimation13_18(self)
    if self.animTimer:IsPastSimMS(100) then
        self:FlashEyes();
        if self.playerRight then
            self.rHandPos.Y = self.bossPos.Y;
        else
            self.lHandPos.Y = self.bossPos.Y;
        end
        
        self:NextBossEvent(true);
    end
end
    
--Smash again.
function PE3BossAnimation13_19(self)
    if self.animTimer:IsPastSimMS(100) then 
        if self.playerRight then
            self.rHandPos.Y = self.bossPos.Y + 160;
            self:SmashEffect(SceneMan:MovePointToGround(Vector(self.rHandPos.X, 0), 10, 0), "Small");
        else
            self.lHandPos.Y = self.bossPos.Y + 160;
            self:SmashEffect(SceneMan:MovePointToGround(Vector(self.lHandPos.X, 0), 10, 0), "Small");
        end
        
        self:NextBossEvent(true);
    end
end
    
--Move the hand up.
function PE3BossAnimation13_20(self)
    if self.animTimer:IsPastSimMS(100) then
        self:FlashEyes();
        if self.playerRight then
            self.rHandPos.Y = self.bossPos.Y;
        else
            self.lHandPos.Y = self.bossPos.Y;
        end
        
        self:NextBossEvent(true);
    end
end

--Smash agai- OH SHIT THE GROUND BROKE
function PE3BossAnimation13_21(self)
    if self.animTimer:IsPastSimMS(100) then 
        --Turn on deep checks for the arm and hand, smash them down, and make the smash effect.
        if self.playerRight then
            self.rArmPartB:EnableDeepCheck(true);
            self.rWrist:EnableDeepCheck(true);
            self.rHandPos.Y = self.bossPos.Y + 230;
            self:SmashEffect(SceneMan:MovePointToGround(Vector(self.rHandPos.X, 0), 10, 0), "Large");
        else
            self.lArmPartB:EnableDeepCheck(true);
            self.lWrist:EnableDeepCheck(true);
            self.lHandPos.Y = self.bossPos.Y + 230;
            self:SmashEffect(SceneMan:MovePointToGround(Vector(self.lHandPos.X, 0), 10, 0), "Large");
        end
        
        --Reveal the underground.
        for x = 864, 1390, 6 do
            for y = 552, 600, 6 do
                SceneMan:RevealUnseen(x, y, Activity.TEAM_1);
            end
        end
        
        self:NextBossEvent(true);
    end
end
    
--Release the player.
function PE3BossAnimation13_22(self)
    if self.animTimer:IsPastSimMS(100) then
        self:ResetLerpSpeeds();
        
        --Continue heaving.
        self:SetHeave(true);
        
        --Let the player move.
        playerActor.PinStrength = 0;
        
        --Change the spawn point.
        self.spawnPos = Vector(1128, 580);
        
        --Create the RPC and digger
        local rpc = CreateHDFirearm("Prison Escape Ep3.rte/RPC M17");
        local digger = CreateHDFirearm("Prison Escape Ep3.rte/Light Digger");
    
        --Open the claw and fling the player. Also, move the RPC into place.
        if self.playerRight then
            self.rIdealClawOpen = self.maxClawOpen;
            playerActor.Pos = playerActor.Pos;
            
            rpc.Pos = Vector(900, 590);
            digger.Pos = Vector(875, 590);
        else
            self.lIdealClawOpen = self.maxClawOpen;
            playerActor.Pos = playerActor.Pos;
            
            rpc.Pos = Vector(1354, 590);
            digger.Pos = Vector(1329, 590);
        end
        
        --Add the items.
        MovableMan:AddItem(rpc);
        MovableMan:AddItem(digger);
        
        --Also, yell about it.
        self:Speak(self.borno, "WHAT!? HOW DID YOU SURVIVE THAT?!", 2500);
        
        self:NextBossEvent(true);
    end
end
    
--Keep the player in place so he is guaranteed to fly for a bit.
function PE3BossAnimation13_23(self)
    playerActor.Pos.Y = 580;
    if self.playerRight then
        playerActor.Vel.X = -20;
        playerActor.AngularVel = 15;
    else
        playerActor.Vel.X = 20;
        playerActor.AngularVel = -15;
    end
    
    if self.animTimer:IsPastSimMS(200) then
        self:NextBossEvent(true);
    end
end
    
--Flash eyes.
function PE3BossAnimation13_24(self)
    if self.animTimer:IsPastSimMS(2700) then
        self:FlashEyes();
        
        self:NextBossEvent(true);
    end
end
    
--Turn on the vacuum and move the hand into place.
function PE3BossAnimation13_25(self)
    if self.animTimer:IsPastSimMS(300) then
        self.vacuumSound = CreateAEmitter("Prison Escape Ep3.rte/Vacuum Start Sound Emitter");
        self.vacuumSound.Pos = self.bossPos;
        MovableMan:AddParticle(self.vacuumSound);
        
        if self.playerRight then
            self:SetWristAngle(true, math.pi * 1.05);
            self.rIdealClawOpen = self.maxClawOpen * 0.5;
            self.rHandPos = self.rHandPos + Vector(10, 10);
        else
            self:SetWristAngle(false, -math.pi * 0.05);
            self.lIdealClawOpen = self.maxClawOpen * 0.5;
            self.lHandPos = self.lHandPos + Vector(10, 10);
        end
    
        self:NextBossEvent(true);
    end
end
    
--Shout at Dafred some more.
function PE3BossAnimation13_26(self)
    if self.animTimer:IsPastSimMS(100) then
        self:Speak(self.borno, "I know you're in there! Come out and play!", 3000);
        
        self:NextBossEvent(true);
    end
end
    
--Start the looping sound.
function PE3BossAnimation13_27(self)
    if self.animTimer:IsPastSimMS(600) then
        self.vacuumSound = CreateAEmitter("Prison Escape Ep3.rte/Vacuum Sound Emitter");
        self.vacuumSound.Pos = self.bossPos;
        MovableMan:AddParticle(self.vacuumSound);
    
        self:NextBossEvent(true);
    end
end

function PE3BossAnimation13_28(self)

end
    
--Borno notices something is amiss.
function PE3BossAnimation13_29(self)
    if self.animTimer:IsPastSimMS(2100) then
        self:Speak(self.borno, "...What's that sound?", 2000);
        
        --Stop heaving
        self:SetHeave(false);
        
        self:NextBossEvent(true);
    end
end
    
--Start falling apart.
function PE3BossAnimation13_30(self)
    if self.animTimer:IsPastSimMS(2100) then
        AudioMan:PlayMusic("Prison Escape Ep3.rte/Sound/Music/ChromeHavocOutro.ogg", 0, -1);
        AudioMan:QueueSilence(99999);
        
        self:Speak(self.borno, "NOOOOOOOOOOOOOOO!", 4000);
        
        --The boss is about to be destroyed, so stop updating it.
        self.bossDisabled = true;
        
        --Gib the wrists and pincers.
        self.rWrist:GibThis();
        self.rPincerA:GibThis();
        self.rPincerB:GibThis();
        self.lWrist:GibThis();
        self.lPincerA:GibThis();
        self.lPincerB:GibThis();
        
        self:NextBossEvent(true);
    end
end
    
--Gib the lower arms.
function PE3BossAnimation13_31(self)
    if self.animTimer:IsPastRealMS(1412) then
        self.rArmPartB:GibThis();
        self.lArmPartB:GibThis();
        
        self:NextBossEvent(true);
    end
end
    
--Gib the upper arms.
function PE3BossAnimation13_32(self)
    if self.animTimer:IsPastRealMS(1412) and self.animEvent == 32 then
        self.rArmPartA:GibThis();
        self.lArmPartA:GibThis();
        
        self:NextBossEvent(true);
    end
end
    
--Gib the upper torso.
function PE3BossAnimation13_33(self)
    if self.animTimer:IsPastRealMS(1412) then
        self.upperBody:GibThis();
        
        --Replace Borno with a version that can be picked up.
        local tempBorno = self.borno;
        self.borno = CreateHDFirearm("Prison Escape Ep3.rte/Handheld Richard Borno");
        self.borno.PresetName = "Richard Borno";
        self.borno.Pos = tempBorno.Pos;
        self.borno.GetsHitByMOs = false;
        MovableMan:AddItem(self.borno);
        tempBorno.ToDelete = true;
        
        self.bossDefeated = true;
        
        self:NextBossEvent(true);
    end
end
    
--Done animating!
function PE3BossAnimation13_34(self)
    self:StartBossAnimation(self.animMode.NONE);
end

-- 14 (WIN)
--Do a little dance, because you just killed the player!
function PE3BossAnimation14(self)

end

function PE3BossAnimation14_0(self)
    --Wait a bit for other animations to finish.
    if self.animTimer:IsPastSimMS(750) then
        --Move the hands up.
        self.rHandPos = self.rArmPartA.Pos + Vector(self.segmentLength * 0.75, -self.segmentLength * 0.75);
        self.lHandPos = self.lArmPartA.Pos + Vector(-self.segmentLength * 0.75, -self.segmentLength * 0.75);
        
        --Heave.
        self:SetHeave(true);
        self.heaveSpeed = self.heaveSpeed * 8;
        self.heaveAmount = self.heaveAmount * 0.5;
        
        --Reset lerp speeds.
        self:ResetLerpSpeeds();
        
        --Move the hands up.
        self.lFlipArm = true;
        self.rFlipArm = true;
        self.rIdealClawOpen = self.minClawOpen;
        self.lIdealClawOpen = self.minClawOpen;
        self:SetWristAngle(true, nil);
        self:SetWristAngle(false, nil);
        self.rHandCrush = false;
        self.lHandCrush = false;
        
        --Gloat.
        self:Speak(self.borno, "Any last words, Dafred? Oh, wait! You're already dead!", 8000);
        
        --Laugh.
        local laughSound = CreateAEmitter("Prison Escape Ep3.rte/Laugh Sound Emitter");
        laughSound.Pos = self.bossPos;
        MovableMan:AddParticle(laughSound);
    
        self:NextBossEvent(true);
    end
end

function PE3BossAnimation14_1(self)

end